// LuaConsoleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "beladraw.h"
#include "lua.h"
#include "LuaConsoleDlg.h"

extern lua_State *lua;
extern BOOL bIsLua;

CLuaConsoleDlg *pThis;

// CLuaConsoleDlg dialog

// IMPLEMENT_DYNAMIC(CLuaConsoleDlg, CDialog)
CLuaConsoleDlg::CLuaConsoleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLuaConsoleDlg::IDD, pParent)
	, outbuffer(_T(""))
	, inbuffer(_T(""))
{
}

CLuaConsoleDlg::~CLuaConsoleDlg()
{
}

void CLuaConsoleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
//	DDX_Text(pDX, IDC_LUA_OUTPUT, outbuffer);
	DDX_Text(pDX, IDC_LUA_INPUT, inbuffer);
	DDX_Control(pDX, IDC_LUA_INPUT, inbufferctrl);
	DDX_Control(pDX, IDC_LUA_OUTPUT, ConsoleOutput);
}


BEGIN_MESSAGE_MAP(CLuaConsoleDlg, CDialog)
	ON_BN_CLICKED(IDC_CLEAR_INPUT, OnBnClickedClearInput)
	ON_BN_CLICKED(IDC_CLEAR_OUTPUT, OnBnClickedClearOutput)
	ON_BN_CLICKED(IDC_EVALUATE, OnBnClickedEvaluate)
END_MESSAGE_MAP()


// CLuaConsoleDlg message handlers
BOOL CLuaConsoleDlg::OnInitDialog()
{	
	CDialog::OnInitDialog();

	pThis=this;
    
	// register lua extensions
    lua_register(lua,"print",lua_Print);

	return TRUE;
}

void CLuaConsoleDlg::ToOutput(CString str)
{
	int Length = ConsoleOutput.GetWindowTextLength();

	ConsoleOutput.SetSel(Length, Length);
	ConsoleOutput.ReplaceSel(str);
	ConsoleOutput.LineScroll( ConsoleOutput.GetLineCount() );
}

int CLuaConsoleDlg::lua_Print(lua_State *L)
{
	// Snatched this from the Lua source code,
	// replacing writes to stdout with my custom
	// output to the LuaConsole's edit box
	int n = lua_gettop(L);				// number of arguments
	int i;
	lua_getglobal(L, "tostring");
	for (i=1; i<=n; i++) {
		CString s;
		lua_pushvalue(L, -1);			// function to be called 
		lua_pushvalue(L, i);			// value to print 
		lua_rawcall(L, 1, 1);
		s = lua_tostring(L, -1);		// get result 
		if (i>1) pThis->ToOutput("\t");
		else pThis->ToOutput("--> ");
		pThis->ToOutput(s);
		lua_pop(L, 1);					// pop result
	}
	pThis->ToOutput("\r\n");
 
	return 0;
} 

void CLuaConsoleDlg::OnBnClickedClearInput()
{
	if (bIsLua!=FALSE) return;

	UpdateData(TRUE);
	inbuffer="";
	UpdateData(FALSE);
}

void CLuaConsoleDlg::OnBnClickedClearOutput()
{
	if (bIsLua!=FALSE) return;

	ConsoleOutput.SetWindowText("");
}

void CLuaConsoleDlg::OnBnClickedEvaluate()
{
	if (bIsLua!=FALSE){
//		PostMessage(WM_KEYDOWN,VK_PAUSE);
		return;
	}

	CString LuaCmd;

	UpdateData();
	ToOutput(inbuffer+"\r\n");
	LuaCmd=inbuffer;
	inbuffer="";
	UpdateData(FALSE);
	bIsLua=TRUE;
//	SetDlgItemText(IDC_EVALUATE,"Break");
	if(lua_dostring(lua,LuaCmd)!=FALSE){
		inbuffer=LuaCmd;
		UpdateData(FALSE);
	}
//	SetDlgItemText(IDC_EVALUATE,"Evaluate");
	bIsLua=FALSE;
}
