// beladrawDoc.cpp : implementation of the CbeladrawDoc class
//

#include "stdafx.h"
#include "beladraw.h"
#include "beladrawDoc.h"
#include "beladrawView.h"
#include "promptbox.h"
#include "MainFrm.h"

BOOL lua_byebye;
int        m_luaWindowStatus;

CString luascriptname;
CbeladrawDoc *pFemmeDoc;

extern lua_State * lua;
extern BOOL bIsLua;
extern int m_luaWindowStatus;

//---------------------Lua Extensions------------------------

void CbeladrawDoc::initalise_lua()
{
	// lua initalisation as called from doc constructor
	bIsLua=FALSE;
	lua=lua_open(4096);
	lua_baselibopen(lua);
	lua_strlibopen(lua);
	lua_mathlibopen(lua);
	lua_iolibopen(lua);

	// add lua error callback
	lua_register(lua,"_ALERT",lua_ERROR); // use a messagebox to display errors
	// register lua extensions
	lua_register(lua,"openbelafile",luaOpenDocument);
    lua_register(lua,"savebelafile",luaSaveDocument);
	lua_register(lua,"createmesh",lua_create_mesh);
	lua_register(lua,"showmesh",lua_show_mesh);
	lua_register(lua,"purgemesh",lua_purge_mesh);
	lua_register(lua,"probdef",lua_prob_def);
	lua_register(lua,"analyse",lua_analyze);
	lua_register(lua,"runpost",lua_runpost);
	lua_register(lua,"addnode",lua_addnode);
	lua_register(lua,"addblocklabel",lua_addlabel);
	lua_register(lua,"addsegment",lua_addline);
	lua_register(lua,"addarc",lua_addarc);
	lua_register(lua,"selectnode",lua_selectnode);
	lua_register(lua,"selectlabel",lua_selectlabel);
	lua_register(lua,"selectsegment",lua_selectsegment);
	lua_register(lua,"selectarcsegment",lua_selectarcsegment);
	lua_register(lua,"clearselected",lua_clearselected);
	lua_register(lua,"setnodeprop",lua_setnodeprop);
	lua_register(lua,"setblockprop",lua_setblockprop);
	lua_register(lua,"setsegmentprop",lua_setsegmentprop);
	lua_register(lua,"setarcsegmentprop",lua_setarcsegmentprop);
	lua_register(lua,"deleteselected",lua_deleteselected);
	lua_register(lua,"deleteselectednodes",lua_deleteselectednodes);
	lua_register(lua,"deleteselectedlabels",lua_deleteselectedlabels);
	lua_register(lua,"deleteselectedsegments",lua_deleteselectedsegments);
	lua_register(lua,"deleteselectedarcsegments",lua_deleteselectedarcsegments);
	lua_register(lua,"zoomnatural",lua_zoomnatural);
	lua_register(lua,"zoomout",lua_zoomout);
	lua_register(lua,"zoomin",lua_zoomin);
	lua_register(lua,"zoom",lua_zoom);
	lua_register(lua,"addmaterial",lua_addmatprop);
	lua_register(lua,"addpointprop",lua_addpointprop);
	lua_register(lua,"addconductorprop",lua_addcircuitprop);
	lua_register(lua,"addboundprop",lua_addboundprop);
	lua_register(lua,"modifymaterial",lua_modmatprop);
	lua_register(lua,"modifyboundprop",lua_modboundprop);
	lua_register(lua,"modifypointprop",lua_modpointprop);
	lua_register(lua,"modifyconductorprop",lua_modcircprop);
	lua_register(lua,"deletematerial",lua_delmatprop);
	lua_register(lua,"deleteboundprop",lua_delboundprop);
	lua_register(lua,"deleteconductor",lua_delcircuitprop);
	lua_register(lua,"deletepointprop",lua_delpointprop);
	lua_register(lua,"moverotate",lua_move_rotate);
	lua_register(lua,"movetranslate",lua_move_translate);
	lua_register(lua,"copyrotate",lua_copy_rotate);
	lua_register(lua,"copytranslate",lua_copy_translate);
	lua_register(lua,"mirror",lua_mirror);
	lua_register(lua,"scale",lua_scale);
	lua_register(lua,"seteditmode",lua_seteditmode);
	lua_register(lua,"selectgroup",lua_selectgroup);
	lua_register(lua,"newdocument",lua_newdocument);
	lua_register(lua,"savebitmap",lua_savebitmap);
	lua_register(lua,"savemetafile",lua_saveWMF);
	lua_register(lua,"exitpre",lua_exitpre);	
	lua_register(lua,"refreshview",lua_updatewindow);
	lua_register(lua,"messagebox",lua_messagebox);
	lua_register(lua,"pause",lua_afxpause);
	lua_register(lua,"shownames",lua_shownames);
	lua_register(lua,"showgrid",lua_showgrid);
	lua_register(lua,"hidegrid",lua_hidegrid);
	lua_register(lua,"gridsnap",lua_gridsnap);
	lua_register(lua,"setgrid",lua_setgrid);
	
	// compatibility lua function names
	lua_register(lua,"open_bela_file",luaOpenDocument);
    lua_register(lua,"save_bela_file",luaSaveDocument);
	lua_register(lua,"create_mesh",lua_create_mesh);
	lua_register(lua,"show_mesh",lua_show_mesh);
	lua_register(lua,"purge_mesh",lua_purge_mesh);
	lua_register(lua,"prob_def",lua_prob_def);
	lua_register(lua,"analyze",lua_analyze);
	lua_register(lua,"run_post",lua_runpost);
	lua_register(lua,"add_node",lua_addnode);
	lua_register(lua,"add_block_label",lua_addlabel);
	lua_register(lua,"add_segment",lua_addline);
	lua_register(lua,"add_arc",lua_addarc);
	lua_register(lua,"select_node",lua_selectnode);
	lua_register(lua,"select_label",lua_selectlabel);
	lua_register(lua,"select_segment",lua_selectsegment);
	lua_register(lua,"select_arcsegment",lua_selectarcsegment);
	lua_register(lua,"clear_selected",lua_clearselected);
	lua_register(lua,"set_node_prop",lua_setnodeprop);
	lua_register(lua,"set_block_prop",lua_setblockprop);
	lua_register(lua,"set_segment_prop",lua_setsegmentprop);
	lua_register(lua,"set_arcsegment_prop",lua_setarcsegmentprop);
	lua_register(lua,"delete_selected",lua_deleteselected);
	lua_register(lua,"delete_selected_nodes",lua_deleteselectednodes);
	lua_register(lua,"delete_selected_labels",lua_deleteselectedlabels);
	lua_register(lua,"delete_selected_segments",lua_deleteselectedsegments);
	lua_register(lua,"delete_selected_arcsegments",lua_deleteselectedarcsegments);
	lua_register(lua,"zoom_natural",lua_zoomnatural);
	lua_register(lua,"zoom_out",lua_zoomout);
	lua_register(lua,"zoom_in",lua_zoomin);
	lua_register(lua,"add_material",lua_addmatprop);
	lua_register(lua,"add_point_prop",lua_addpointprop);
	lua_register(lua,"add_conductor_prop",lua_addcircuitprop);
	lua_register(lua,"add_bound_prop",lua_addboundprop);
	lua_register(lua,"modify_material",lua_modmatprop);
	lua_register(lua,"modify_bound_prop",lua_modboundprop);
	lua_register(lua,"modify_point_prop",lua_modpointprop);
	lua_register(lua,"modify_conductor_prop",lua_modcircprop);
	lua_register(lua,"delete_material",lua_delmatprop);
	lua_register(lua,"delete_bound_prop",lua_delboundprop);
	lua_register(lua,"delete_conductor",lua_delcircuitprop);
	lua_register(lua,"delete_point_prop",lua_delpointprop);
	lua_register(lua,"move_rotate",lua_move_rotate);
	lua_register(lua,"move_translate",lua_move_translate);
	lua_register(lua,"copy_rotate",lua_copy_rotate);
	lua_register(lua,"copy_translate",lua_copy_translate);
	lua_register(lua,"set_edit_mode",lua_seteditmode);
	lua_register(lua,"select_group",lua_selectgroup);
	lua_register(lua,"new_document",lua_newdocument);
	lua_register(lua,"save_bitmap",lua_savebitmap);
	lua_register(lua,"save_metafile",lua_saveWMF);
	lua_register(lua,"exit_pre",lua_exitpre);	
	lua_register(lua,"refresh_view",lua_updatewindow);
	lua_register(lua,"message_box",lua_messagebox);
	lua_register(lua,"prompt",lua_promptbox);
	lua_register(lua,"show_grid",lua_showgrid);
	lua_register(lua,"hide_grid",lua_hidegrid);
	lua_register(lua,"grid_snap",lua_gridsnap);
	lua_register(lua,"set_grid",lua_setgrid);
	lua_register(lua,"show_names",lua_shownames);

	lua_setlinehook(lua,line_hook);

	hProc=NULL;

	pFemmeDoc=(CbeladrawDoc *)this;

	LuaConsole.Create(IDD_LUACONSOLE);
	if ((d_luaconsole!=FALSE) && (m_luaWindowStatus!=SW_MINIMIZE))
		LuaConsole.ShowWindow(SW_SHOW);

	// define some initial variables
	lua_dostring(lua,"eo=8.85418781762e-12\n");
}

void CbeladrawDoc::line_hook(lua_State *L, lua_Debug *ar)
{

	BOOL bIllegal=FALSE;
    MSG msg;

	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) 
	{ 
		if ((msg.message == WM_KEYDOWN) && (msg.wParam == VK_PAUSE))
		{
			bIsLua=FALSE;
			bIllegal=TRUE;
	
			// If there is a running process like the solver or
			// the post-processor, kill it
			CbeladrawDoc * thisDoc;
			thisDoc=(CbeladrawDoc *)pFemmeDoc;
			if (thisDoc->hProc!=NULL) TerminateProcess(thisDoc->hProc,NULL);
			thisDoc->hProc=NULL;

			MessageBeep(MB_ICONEXCLAMATION);

			lua_error(L,NULL);
		}
		if(msg.message==WM_KEYDOWN) bIllegal=TRUE;

		// should these be blocked?
//		if(msg.message==WM_LBUTTONDOWN) bIllegal=TRUE;
//		if(msg.message==WM_RBUTTONDOWN) bIllegal=TRUE;
//		if(msg.message==WM_LBUTTONUP) bIllegal=TRUE;
		if(msg.message==WM_LBUTTONDBLCLK) bIllegal=TRUE;
		if(msg.message==WM_RBUTTONDBLCLK) bIllegal=TRUE;
	
		// side-track all commands
		if(msg.message==WM_COMMAND)
		{
			UINT wID=LOWORD(msg.wParam);  
			if(wID==ID_FILE_OPEN) bIllegal=TRUE;
			if(wID==ID_FILE_NEW) bIllegal=TRUE;
			if(wID==ID_FILE_SAVE) bIllegal=TRUE;
			if(wID==ID_FILE_SAVE_AS) bIllegal=TRUE;
			if(wID==ID_APP_EXIT) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE1) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE2) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE3) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE4) bIllegal=TRUE;
			if(wID==ID_DEFINE_PROBLEM) bIllegal=TRUE;
			if(wID==ID_EDIT_MATPROPS) bIllegal=TRUE;
			if(wID==ID_EDIT_PTPROPS) bIllegal=TRUE;
			if(wID==ID_EDIT_CIRCPROPS) bIllegal=TRUE;
			if(wID==ID_FILE_OPEN_LUA_SCRIPT) bIllegal=TRUE;
			if(wID==ID_NODE_OP) bIllegal=TRUE;
			if(wID==ID_SEGMENT_OP) bIllegal=TRUE; 
			if(wID==ID_ZOOM_NATURAL) bIllegal=TRUE; 
			if(wID==ID_ZOOM_WND) bIllegal=TRUE; 
			if(wID==ID_EDIT_COPY) bIllegal=TRUE; 
			if(wID==ID_BLOCK_OP) bIllegal=TRUE; 
			if(wID==ID_MAKE_MESH) bIllegal=TRUE; 
			if(wID==ID_MENU_ANALYZE) bIllegal=TRUE; 
			if(wID==ID_MENU_VIEWRES) bIllegal=TRUE; 
			if(wID==ID_ARCSEG_OP) bIllegal=TRUE;
			if(wID==ID_UNDO) bIllegal=TRUE;
			if(wID==ID_KBDZOOM) bIllegal=TRUE; 
			if(wID==ID_MOVE_OBJECTS) bIllegal=TRUE; 
			if(wID==ID_COPY_OBJECTS) bIllegal=TRUE; 
			if(wID==ID_DXFIN) bIllegal=TRUE; 
			if(wID==ID_PURGEMESH) bIllegal=TRUE; 
			if(wID==ID_DXFWRITE) bIllegal=TRUE;
			if(wID==ID_SELECTWND) bIllegal=TRUE; 
			if(wID==ID_PAN_DOWN) bIllegal=TRUE; 
			if(wID==ID_PAN_LEFT) bIllegal=TRUE; 
			if(wID==ID_PAN_RIGHT) bIllegal=TRUE; 
			if(wID==ID_PAN_UP) bIllegal=TRUE; 
			if(wID==ID_MENU_MATLIB) bIllegal=TRUE; 
			if(wID==ID_HELP_REGISTER) bIllegal=TRUE; 
			if(wID==ID_HELP_FINDER) bIllegal=TRUE; 
			if(wID==ID_GROUP_OP) bIllegal=TRUE;
			if(wID==ID_OPEN_SELECTED) bIllegal=TRUE; 
			if(wID==ID_EDIT_SCALE) bIllegal=TRUE; 
			if(wID==ID_EDIT_MIRROR) bIllegal=TRUE; 
			if(wID==ID_EDIT_CUT) bIllegal=TRUE; 
			if(wID==ID_EDIT_PREFS) bIllegal=TRUE;
			if(wID==ID_EDIT_COPY_AS_METAFILE) bIllegal=TRUE; 
			if(wID==ID_ZOOM_IN) bIllegal=TRUE; 
			if(wID==ID_ZOOM_OUT) bIllegal=TRUE; 
			if(wID==ID_SHOW_GRID) bIllegal=TRUE; 
			if(wID==ID_SET_GRID) bIllegal=TRUE; 
			if(wID==ID_SNAP_GRID) bIllegal=TRUE; 
			if(wID==ID_SHOW_MESH) bIllegal=TRUE; 
		}
		
		if (bIllegal==FALSE) DispatchMessage(&msg);
	}

}

void CbeladrawDoc::OnFileOpenLuaScript()
{
    static char BASED_CODE szFilter[] = "Lua Script Files (*.lua)|*.lua|";
    char ext[]=".lua";
    CFileDialog MyDlg(TRUE,ext,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);
    if(MyDlg.DoModal()==IDOK)
    {
        luascriptname=MyDlg.GetPathName();
        luathread((void *) this);
    }
}

UINT CbeladrawDoc::luathread(LPVOID pParam)
{
	// catch the case in which luathread is called
	// "by accident" with no scriptname
	if (luascriptname.GetLength()==0) return 0;
	
	// make sure everything gets drawn once;
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);
	if(thisDoc->FirstDraw!=0)
	{
		theView->InvalidateRect(NULL);
		theView->UpdateWindow();
	}

	int lua_error_code;
	
	lua_byebye=FALSE;
	
	bIsLua=TRUE;
	if (lua_error_code=lua_dofile(lua,luascriptname)!=0)
	{
		//somthing whent wrong !
		if (lua_error_code==LUA_ERRRUN)
			AfxMessageBox("Run Error");
		if (lua_error_code==LUA_ERRSYNTAX)
			AfxMessageBox("Syntax Error");
		if (lua_error_code==LUA_ERRMEM)
			AfxMessageBox("Lua memory Error");
		if (lua_error_code==LUA_ERRERR)
			AfxMessageBox("User error error");
		if (lua_error_code==LUA_ERRFILE)
			AfxMessageBox("File Error");
	}
	bIsLua=FALSE;

	// if the "shut down" flag has been raised, shut
	// the program down in a "gentle" way.  This code
	// does the same thing that happens when you 
	// double-click on the main window close box
	if(lua_byebye==TRUE){
		ASSERT(AfxGetMainWnd() != NULL);
		AfxGetMainWnd()->PostMessage(WM_CLOSE);
	}

	return 0;
}


int CbeladrawDoc::lua_exitpre(lua_State *L)
{
	lua_byebye=TRUE;
	return 0;
}

int CbeladrawDoc::luaOpenDocument(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	int n;
	n=lua_gettop(L);

	CString temp;
	temp.Format("%s",lua_tostring(L,n));
	if (thisDoc->OnOpenDocument(temp)!=FALSE) 
		thisDoc->SetPathName(temp);

	return 0;
}

int CbeladrawDoc::luaSaveDocument(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	int n;
	n=lua_gettop(L);

	CString temp;
	temp.Format("%s",lua_tostring(L,n));
	thisDoc->OnSaveDocument(temp);
	thisDoc->SetPathName(temp);

	return 0;
}

int CbeladrawDoc::lua_prob_def(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	
	CString units,type;
	int n;
	n=lua_gettop(L);

	// error traps
	int LengthUnits=-1;
	int ProblemType=-1;
	double Precision;

	units.Format("%s",lua_tostring(L,1));
	type.Format("%s",lua_tostring(L,2));
	Precision=lua_tonumber(L,3);
	if(units=="inches") LengthUnits=0;
	if(units=="millimeters") LengthUnits=1;
	if(units=="centimeters") LengthUnits=2;
	if(units=="meters") LengthUnits=3;
	if(units=="mills") LengthUnits=4;
	if(units=="mils") LengthUnits=4;
	if(units=="micrometers") LengthUnits=5;
	if(type=="planar") ProblemType=0;
	if(type=="axi") ProblemType=1;
	if (ProblemType==0) thisDoc->Depth=lua_tonumber(L,4);

	// error detection and nice variable handling

	if (LengthUnits==-1)
	{
		CString msg;
		msg.Format("Unknown length unit %s",units);
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}
	else
	{
		thisDoc->LengthUnits=LengthUnits;
	}

	if (ProblemType==-1)
	{
		CString msg;
		msg.Format("Unknown problem type %s",type);
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}
	else
	{
		thisDoc->ProblemType=ProblemType;
	}


	if (Precision < 1.e-16 || Precision >1.e-8)
	{
		CString msg;
		msg.Format("Invalid Precision %lf",Precision);
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}
	else
	{
		thisDoc->Precision=Precision;
	}

	if (thisDoc->Depth<0) thisDoc->Depth=1;

//	CString temp;
//	temp.Format("%s",lua_tostring(L,n));


	

	return 0;
}

int CbeladrawDoc::lua_create_mesh(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	theView->lnuMakeMesh();

	return 0;
}

int CbeladrawDoc::lua_show_mesh(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	theView->lnu_show_mesh();

	return 0;
}

int CbeladrawDoc::lua_purge_mesh(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	theView->lnu_purge_mesh();

	return 0;
}

int CbeladrawDoc::lua_analyze(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);
	 
	int n=lua_gettop(L);
	if (n>0) n=(int)lua_tonumber(L,1);
	if (n!=0) n=1;
	
	theView->lnu_analyze(n);

	return 0;
}

int CbeladrawDoc::lua_runpost(lua_State *L)
{
        CString scriptfilename;
        scriptfilename.Format("%s",lua_tostring(L,1));

        // backward compatibility

        if (scriptfilename.Left(1)=="-")
        {
                scriptfilename=scriptfilename.Mid(1,scriptfilename.GetLength()-1);
        }


        CString vars,outparm;
		BOOL bHide=FALSE;
        int n;
        n=lua_gettop(L);
        vars="";
        if (n>1)
        {// we have vars as well
                for (int x=2 ;x<=n;x++)
                {
					outparm=lua_tostring(L,x);
					if((outparm.CompareNoCase("-windowhide")==0) ||
					   (outparm.CompareNoCase("-window_hide")==0))
					{
						bHide=TRUE;
						outparm="-windowhide";
					}
					vars=vars+" "+outparm;
                }
                scriptfilename+=vars; // append variable list
        }
        CbeladrawDoc * thisDoc;
        CbeladrawView * theView;

        thisDoc=(CbeladrawDoc *)pFemmeDoc;
        POSITION pos;
        pos=thisDoc->GetFirstViewPosition();
        theView=(CbeladrawView *)thisDoc->GetNextView(pos);

        theView->lnu_runpost(scriptfilename,bHide);

		return 0;
}


int CbeladrawDoc::lua_addnode(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	double x,y,d;

	
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();

	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);

//	if(thisDoc->Coords)
//	{
//		double r,t;
//		r=mx;
//		t=my*PI/180;
//		x=mx*cos(t);
//		y=mx*sin(t);
//	}
	
	if (thisDoc->nodelist.GetSize()<2) d=1.e-08;
	else{
		CComplex p0,p1,p2;
		p0=thisDoc->nodelist[0].CC();
		p1=p0;
		for(int i=1;i<thisDoc->nodelist.GetSize();i++)
		{
			p2=thisDoc->nodelist[i].CC();
			if(p2.re<p0.re) p0.re=p2.re;
			if(p2.re>p1.re) p1.re=p2.re;
			if(p2.im<p0.im) p0.im=p2.im;
			if(p2.im>p1.im) p1.im=p2.im;
		}
		d=abs(p1-p0)*1.e-06;
	}
	BOOL flag;
	flag=thisDoc->AddNode(x,y,d);
	
	if(flag==TRUE){
		theView->MeshUpToDate=FALSE;
		if(theView->MeshFlag==TRUE) theView->lnu_show_mesh();
		else theView->DrawPSLG();
	}

	return 0;
}

int CbeladrawDoc::lua_addlabel(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	double x,y,d;

	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

//	if(thisDoc->Coords)
//	{
//		double r,t;
//		r=mx;
//		t=my*PI/180;
//		x=mx*cos(t);
//		y=mx*sin(t);
//	}

	if (thisDoc->nodelist.GetSize()<2) d=1.e-08;
	else{
		CComplex p0,p1,p2;
		p0=thisDoc->nodelist[0].CC();
		p1=p0;
		for(int i=1;i<thisDoc->nodelist.GetSize();i++)
		{
			p2=thisDoc->nodelist[i].CC();
			if(p2.re<p0.re) p0.re=p2.re;
			if(p2.re>p1.re) p1.re=p2.re;
			if(p2.im<p0.im) p0.im=p2.im;
			if(p2.im>p1.im) p1.im=p2.im;
		}
		d=abs(p1-p0)*1.e-06;
	}
	BOOL flag;
	flag=thisDoc->AddBlockLabel(x,y,d);
	
	return 0;
}


int CbeladrawDoc::lua_addline(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	CPoint mypntstart,mypntend;

	double sx,sy,ex,ey;

	sx=lua_tonumber(L,1);
	sy=lua_tonumber(L,2);

	ex=lua_tonumber(L,3);
	ey=lua_tonumber(L,4);

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();

	theView=(CbeladrawView *)thisDoc->GetNextView(pos);
	BOOL flag;

	flag=thisDoc->AddSegment(thisDoc->ClosestNode(sx,sy),thisDoc->ClosestNode(ex,ey));

	if(flag==TRUE)
	{
		theView->MeshUpToDate=FALSE;
		if(theView->MeshFlag==TRUE) theView->lnu_show_mesh();
		else theView->DrawPSLG(); 
	}
	else theView->DrawPSLG();
	
	return 0;
}

int CbeladrawDoc::lua_addarc(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	
	double sx,sy,ex,ey;
	double angle,maxseg;

	sx=lua_tonumber(L,1);
	sy=lua_tonumber(L,2);
	ex=lua_tonumber(L,3);
	ey=lua_tonumber(L,4);

	angle=lua_tonumber(L,5);
	maxseg=lua_tonumber(L,6);

	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();

	theView=(CbeladrawView *)thisDoc->GetNextView(pos);
	BOOL flag;

	CArcSegment asegm;
	asegm.n0=thisDoc->ClosestNode(sx,sy);
	asegm.n1=thisDoc->ClosestNode(ex,ey);
	thisDoc->nodelist[asegm.n1].ToggleSelect();
	theView->DrawPSLG();

	asegm.MaxSideLength=maxseg;
	asegm.ArcLength=angle;
	asegm.BoundaryMarker="<None>";

	flag=thisDoc->AddArcSegment(asegm);
	flag=FALSE;
	thisDoc->UnselectAll();
	if(flag==TRUE){
		theView->MeshUpToDate=FALSE;
		if(theView->MeshFlag==TRUE) theView->lnu_show_mesh();
		else theView->DrawPSLG(); 
	}
	else theView->DrawPSLG();
		
	return 0;
}

int CbeladrawDoc::lua_selectnode(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	
	double mx,my;
	mx=lua_tonumber(L,1);
	my=lua_tonumber(L,2);
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int node;
	node=thisDoc->ClosestNode(mx,my);
	thisDoc->nodelist[node].ToggleSelect();

	return 0;
}

int CbeladrawDoc::lua_selectlabel(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;

	double mx,my;
	mx=lua_tonumber(L,1);
	my=lua_tonumber(L,2);
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int node;
	node=thisDoc->ClosestBlockLabel(mx,my);
	thisDoc->blocklist[node].ToggleSelect();

	return 0;
}


int CbeladrawDoc::lua_selectsegment(lua_State *L)
{	
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;

	double mx,my;
	mx=lua_tonumber(L,1);
	my=lua_tonumber(L,2);
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int node;
	node=thisDoc->ClosestSegment(mx,my);
	thisDoc->linelist[node].ToggleSelect();

	return 0;
}


int CbeladrawDoc::lua_selectarcsegment(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;

	double mx,my;
	mx=lua_tonumber(L,1);
	my=lua_tonumber(L,2);
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int node;
	node=thisDoc->ClosestArcSegment(mx,my);
	thisDoc->arclist[node].ToggleSelect();

	return 0;
}

int CbeladrawDoc::lua_clearselected(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	thisDoc->UnselectAll();
	return 0;
}

int CbeladrawDoc::lua_setnodeprop(lua_State *L)
{
	CString nodeprop,inconductor;
	int groupno;

	nodeprop.Format("%s",lua_tostring(L,1));
	groupno=(int) lua_tonumber(L,2);
	inconductor.Format("%s",lua_tostring(L,3));

	if (groupno<0)
	{
	CString msg;
	msg.Format("Invalid group no %d",groupno);
	lua_error(L,msg.GetBuffer(1));
	return 0;
	}

	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int i;

	// check to see how many (if any) nodes are selected.
	for(i=0;i<thisDoc->nodelist.GetSize();i++)
	{
		if(thisDoc->nodelist[i].IsSelected==TRUE)
		{
			thisDoc->nodelist[i].InGroup=groupno;
			thisDoc->nodelist[i].BoundaryMarker=nodeprop;
			thisDoc->nodelist[i].InConductor=inconductor;
		}			
	}

	return 0;
}

int CbeladrawDoc::lua_setblockprop(lua_State *L)
{
	CString blocktype;
	BOOL automesh;
	double meshsize;
	int group;

	blocktype.Format("%s",lua_tostring(L,1));
	automesh=(int) lua_tonumber(L,2);
	meshsize=lua_tonumber(L,3);
	group=(int) lua_tonumber(L,4);

	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int i;	

	for(i=0;i<thisDoc->blocklist.GetSize();i++)
	{
		if(thisDoc->blocklist[i].IsSelected==TRUE)
		{
			thisDoc->blocklist[i].MaxArea=PI*meshsize*meshsize/4.;
			thisDoc->blocklist[i].BlockType=blocktype;
			thisDoc->blocklist[i].InGroup=group;
			if(automesh==1) thisDoc->blocklist[i].MaxArea=0;
		}
	}
	
	return 0;
}

int CbeladrawDoc::lua_setsegmentprop(lua_State *L)
{
	CString prop,inconductor;
	double elesize;
	int automesh,hide,group;

	prop.Format("%s",lua_tostring(L,1));
	elesize=lua_tonumber(L,2);
	automesh=(int) lua_tonumber(L,3);
	hide=(int) lua_tonumber(L,4);
	group=(int) lua_tonumber(L,5);
	inconductor.Format("%s",lua_tostring(L,6));

	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	for(int i=0;i<thisDoc->linelist.GetSize();i++)
	{
		if(thisDoc->linelist[i].IsSelected==TRUE){
			if (automesh==1) thisDoc->linelist[i].MaxSideLength=-1;
			else{
				if (elesize>0) 
					thisDoc->linelist[i].MaxSideLength=elesize;
				else elesize=-1;
			}
			thisDoc->linelist[i].BoundaryMarker=prop;
			thisDoc->linelist[i].Hidden=hide;
			thisDoc->linelist[i].InGroup=group;
			thisDoc->linelist[i].InConductor=inconductor;
		}
	}

	return 0;
}

int CbeladrawDoc::lua_setarcsegmentprop(lua_State *L)
{
	CString boundprop,inconductor;
	double maxsegdeg;
	int hide,group;

	maxsegdeg=lua_tonumber(L,1);
	boundprop.Format("%s",lua_tostring(L,2));
	hide=(int) lua_tonumber(L,3);
	group=(int) lua_tonumber(L,4);
	inconductor.Format("%s",lua_tostring(L,5));

	CbeladrawDoc *thisDoc;
	CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int i;

	for(i=0;i<thisDoc->arclist.GetSize();i++)
	{
		if(thisDoc->arclist[i].IsSelected==TRUE){
			thisDoc->arclist[i].BoundaryMarker=boundprop;
			thisDoc->arclist[i].MaxSideLength=maxsegdeg;
			thisDoc->arclist[i].Hidden=hide;
			thisDoc->arclist[i].InGroup=group;
			thisDoc->arclist[i].InConductor=inconductor;
		}
	}

	return 0;
}

int CbeladrawDoc::lua_deleteselectednodes(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	thisDoc->DeleteSelectedNodes();
	return 0;
}

int CbeladrawDoc::lua_deleteselectedlabels(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	thisDoc->DeleteSelectedBlockLabels();
	return 0;

}

int CbeladrawDoc::lua_deleteselectedsegments(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	thisDoc->DeleteSelectedSegments();
	return 0;
}

int CbeladrawDoc::lua_deleteselectedarcsegments(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	thisDoc->DeleteSelectedArcSegments();
	return 0;
}

int CbeladrawDoc::lua_deleteselected(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;

	thisDoc->DeleteSelectedSegments();
	thisDoc->DeleteSelectedArcSegments();
	thisDoc->DeleteSelectedNodes();
	thisDoc->DeleteSelectedBlockLabels();	
	
	return 0;
}

int CbeladrawDoc::lua_newdocument(lua_State *L)
{
	CbeladrawDoc * thisDoc;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	thisDoc->OnNewDocument();
	thisDoc->SetPathName("Untitled",FALSE);
	thisDoc->SetTitle("Untitled");
	return 0;
}


int CbeladrawDoc::lua_zoomnatural(lua_State *L)
{
	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);
	theView->lua_zoomnatural();

	return 0;
}


int CbeladrawDoc::lua_zoomout(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	theView->lua_zoomout();
	
	return 0;
}

int CbeladrawDoc::lua_zoomin(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);
	theView->lua_zoomin();

//	PostMessage(theView->m_hWnd,WM_COMMAND,0,ID_ZOOM_IN);
// it would be nice to use messages but I need to check the format first
// this would cut down on code used twice and some unnecessary code !

	
	return 0;
}

int CbeladrawDoc::lua_zoom(lua_State *L)
{

	double x[2],y[2],m[2];

	x[0]=lua_tonumber(L,1);
	y[0]=lua_tonumber(L,2);
	x[1]=lua_tonumber(L,3);
	y[1]=lua_tonumber(L,4);
	
	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CRect r;
	theView->ox=x[0]; theView->oy=y[0];
	theView->GetClientRect(&r);
	m[0]=((double) (r.right-1))/(x[1]-x[0]);
	m[1]=((double) (r.bottom-1))/(y[1]-y[0]);

	if(m[0]<m[1]) theView->mag=m[0];
	else theView->mag=m[1];

	theView->Invalidate(TRUE);
	return 0;
}


int CbeladrawDoc::lua_copy_rotate(lua_State *L)
{
	CbeladrawDoc *thisDoc;
	CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int n;
	n=lua_gettop(L);
	// IF N=5 WE Have an edit action, if n=4 we dont !

	int EditAction,copies;

	double x,y,angle;
	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);
	angle=lua_tonumber(L,3);
	copies=(int) lua_tonumber(L,4);

	if (n==5) EditAction=(int) lua_tonumber(L,5);
	if (n==4) EditAction=theView->EditAction;

	if(n!=4 && n!=5)
	{
		CString msg;
		msg.Format("Invalid number of parameters for copy rotate");
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}
	
	thisDoc->RotateCopy(CComplex(x,y),angle,copies,EditAction);		
	thisDoc->meshnode.RemoveAll();
	thisDoc->meshline.RemoveAll();
	thisDoc->greymeshline.RemoveAll();
	theView->MeshFlag=FALSE;
	theView->MeshUpToDate=FALSE;
	theView->InvalidateRect(NULL);

	return 0;
}

int CbeladrawDoc::lua_copy_translate(lua_State *L)
{
	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int n;
	n=lua_gettop(L);

	int EditAction, copies;
	double x,y;
	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);
	copies=(int) lua_tonumber(L,3);

	if (n==4) EditAction=(int) lua_tonumber(L,4);
	if (n==3) EditAction=theView->EditAction;

	if(n!=4 && n!=3)
	{
		CString msg;
		msg.Format("Invalid number of parameters for copy translate");
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}


	thisDoc->UpdateUndo();
	thisDoc->TranslateCopy(x,y,copies,EditAction);
	thisDoc->meshnode.RemoveAll();
	thisDoc->meshline.RemoveAll();
	thisDoc->greymeshline.RemoveAll();
	theView->MeshFlag=FALSE;
	theView->MeshUpToDate=FALSE;
	theView->InvalidateRect(NULL);

	return 0;
}


int CbeladrawDoc::lua_move_translate(lua_State *L)
{

	double x,y;
	int EditAction;

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int n;
	n=lua_gettop(L);

	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);

	if (n==3) EditAction=(int) lua_tonumber(L,3);
	if (n==2) EditAction=theView->EditAction;

		if(n!=3 && n!=2)
	{
		CString msg;
		msg.Format("Invalid number of parameters for move translate");
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}


	{
			thisDoc->UpdateUndo();
			thisDoc->TranslateMove(x,y,EditAction);
			thisDoc->meshnode.RemoveAll();
			thisDoc->meshline.RemoveAll();
			thisDoc->greymeshline.RemoveAll();
			theView->MeshFlag=FALSE;
			theView->MeshUpToDate=FALSE;
			theView->InvalidateRect(NULL);
	}

	return 0;
}

int CbeladrawDoc::lua_move_rotate(lua_State *L)
{

	double x,y,shiftangle;
	int EditAction;

	int n;
	n=lua_gettop(L);

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);
	shiftangle=lua_tonumber(L,3);

	if (n==4) EditAction=(int) lua_tonumber(L,4);
	if (n==3) EditAction=theView->EditAction;

	if(n!=4 && n!=3)
	{
		CString msg;
		msg.Format("Invalid number of parameters for move rotate");
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}


	{
		thisDoc->UpdateUndo();
		thisDoc->RotateMove(CComplex(x,y),shiftangle,EditAction);
		thisDoc->meshnode.RemoveAll();
		thisDoc->meshline.RemoveAll();
		thisDoc->greymeshline.RemoveAll();
		theView->MeshFlag=FALSE;
		theView->MeshUpToDate=FALSE;
		theView->InvalidateRect(NULL);
	}

	return 0;
}


int CbeladrawDoc::lua_mirror(lua_State *L)
{
	double m_pax,m_pay,m_pbx,m_pby;
	int EditAction;

	CbeladrawDoc *thisDoc;
	CbeladrawView *theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int n;
	n=lua_gettop(L);

	m_pax=lua_tonumber(L,1);
	m_pay=lua_tonumber(L,2);
	m_pbx=lua_tonumber(L,3);
	m_pby=lua_tonumber(L,4);

	if (n==5) EditAction=(int) lua_tonumber(L,5);
	if (n==4) EditAction=theView->EditAction;

	if(n!=4 && n!=5)
	{
		CString msg;
		msg.Format("Invalid number of parameters for mirror");
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}


	thisDoc->UpdateUndo();
	thisDoc->MirrorSelected(m_pax,m_pay,m_pbx,m_pby,EditAction);
	theView->InvalidateRect(NULL);

	return 0;
}

int CbeladrawDoc::lua_scale(lua_State *L)
{
	int EditAction;
	double x,y,scalefactor;

	int n;
	n=lua_gettop(L);

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	x=lua_tonumber(L,1);
	y=lua_tonumber(L,2);
	scalefactor=lua_tonumber(L,3);
	EditAction=(int) lua_tonumber(L,4);

	if (n==4) EditAction=(int) lua_tonumber(L,4);
	if (n==3) EditAction=theView->EditAction;

		if(n!=4 && n!=3)
	{
		CString msg;
		msg.Format("Invalid number of parameters for scale");
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}


	thisDoc->UpdateUndo();
	thisDoc->ScaleMove(x,y,scalefactor,EditAction);
	theView->InvalidateRect(NULL);

	return 0;
}


int CbeladrawDoc::lua_seteditmode(lua_State *L)
{
	CString EditAction;
	
	EditAction.Format("%s",lua_tostring(L,1));
	EditAction.MakeLower();

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	int iEditAction;
	iEditAction=-1;

	if (EditAction=="nodes") iEditAction=0;
	if (EditAction=="segments") iEditAction=1;
	if (EditAction=="blocks") iEditAction=2;
	if (EditAction=="arcsegments") iEditAction=3;
	if (EditAction=="group") iEditAction=4;

	if(iEditAction==-1)
	{
		CString msg;
		msg.Format("Invalid Edit Action %s",EditAction);
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}
	else
	{
		theView->EditAction=iEditAction;
	}


	return 0;
}

int CbeladrawDoc::lua_selectgroup(lua_State *L)
{

	int group,i;
	group=(int) lua_tonumber(L,1);

	if(group<0)
	{
		CString msg;
		msg.Format("Invalid group %d",group);
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}


	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

//	thisDoc->UnselectAll();

	// select nodes
	for(i=0;i<thisDoc->nodelist.GetSize();i++)
	{
		if(thisDoc->nodelist[i].InGroup==group)
			thisDoc->nodelist[i].IsSelected=TRUE;
	}

	// select segments
	for(i=0;i<thisDoc->linelist.GetSize();i++)
	{
		if(thisDoc->linelist[i].InGroup==group)
			thisDoc->linelist[i].IsSelected=TRUE;
	}

	// select arc segments
	for(i=0;i<thisDoc->arclist.GetSize();i++)
	{
		if(thisDoc->arclist[i].InGroup==group)
			thisDoc->arclist[i].IsSelected=TRUE;
	}

	// select blocks
	for(i=0;i<thisDoc->blocklist.GetSize();i++)
	{
		if(thisDoc->blocklist[i].InGroup==group)
		thisDoc->blocklist[i].IsSelected=TRUE;
	}


	theView->EditAction=4; // set to group

	return 0;
}


int CbeladrawDoc::lua_addmatprop(lua_State *L)
{
	CString BlockName;
	double m_ex,m_ey,m_qv;
	int n;
	
	n=lua_gettop(L);

	BlockName.Format("%s",lua_tostring(L,1));
	m_ex=lua_tonumber(L,2);
	m_ey=lua_tonumber(L,3);
	m_qv=lua_tonumber(L,4);

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CMaterialProp MProp;
	thisDoc->blockproplist.Add(MProp);
	int k=thisDoc->blockproplist.GetSize()-1;
	thisDoc->blockproplist[k].BlockName=BlockName;
	thisDoc->blockproplist[k].ex=m_ex;
	thisDoc->blockproplist[k].ey=m_ey;
	thisDoc->blockproplist[k].qv=m_qv;	

	return 0;
}



int CbeladrawDoc::lua_modmatprop(lua_State *L)
{
	CString BlockName;
	int k,modprop;

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	// find the index of the material to modify;
	if (thisDoc->blockproplist.GetSize()==0) return TRUE;
	BlockName.Format("%s",lua_tostring(L,1));
	for(k=0;k<thisDoc->blockproplist.GetSize();k++)
		if(BlockName==thisDoc->blockproplist[k].BlockName) break;
	
	// get out of here if there's no matching material
	if(k==thisDoc->blockproplist.GetSize()) return TRUE;

	modprop=(int) lua_tonumber(L,2);
	
	// now, modify the specified attribute...
	switch(modprop)
	{
		case 0:
			thisDoc->blockproplist[k].BlockName.Format("%s",lua_tostring(L,3));
			break;
		case 1:
			thisDoc->blockproplist[k].ex=lua_tonumber(L,3);
			break;
		case 2:
			thisDoc->blockproplist[k].ey=lua_tonumber(L,3);
			break;
		case 3:
			thisDoc->blockproplist[k].qv=lua_tonumber(L,3);
			break;
		default:
			break;
	}
	
	return 0;
}

int CbeladrawDoc::lua_addboundprop(lua_State *L)
{

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CString m_BdryName;
	double m_v, m_qs, m_c0, m_c1;
	int m_BdryFormat;
	m_BdryName.Format("%s",lua_tostring(L,1));
	m_v=lua_tonumber(L,2);
	m_qs=lua_tonumber(L,3);
	m_c0=lua_tonumber(L,4);
	m_c1=lua_tonumber(L,5);
	m_BdryFormat=(int) lua_tonumber(L,6);

	CBoundaryProp MProp;
	thisDoc->lineproplist.Add(MProp);

	int k=thisDoc->lineproplist.GetSize()-1;
	thisDoc->lineproplist[k].BdryName=m_BdryName;
	thisDoc->lineproplist[k].BdryFormat=m_BdryFormat;
	thisDoc->lineproplist[k].V	=m_v;
	thisDoc->lineproplist[k].qs	=m_qs;
	thisDoc->lineproplist[k].c0	=m_c0;
	thisDoc->lineproplist[k].c1	=m_c1;

	return 0;
}

int CbeladrawDoc::lua_modboundprop(lua_State *L)
{
	CString BdryName;
	int k,modprop;

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	// find the index of the boundary property to modify;
	if (thisDoc->lineproplist.GetSize()==0) return TRUE;
	BdryName.Format("%s",lua_tostring(L,1));
	for(k=0;k<thisDoc->lineproplist.GetSize();k++)
		if(BdryName==thisDoc->lineproplist[k].BdryName) break;
	
	// get out of here if there's no matching material
	if(k==thisDoc->lineproplist.GetSize()) return TRUE;

	modprop=(int) lua_tonumber(L,2);
	
	// now, modify the specified attribute...
	switch(modprop)
	{
		case 0:
			thisDoc->lineproplist[k].BdryName.Format("%s",lua_tostring(L,3));
			break;
		case 1:
			thisDoc->lineproplist[k].V	=lua_tonumber(L,3);
			break;
		case 2:
			thisDoc->lineproplist[k].qs	=lua_tonumber(L,3);
			break;
		case 3:
			thisDoc->lineproplist[k].c0	=lua_tonumber(L,3);
			break;
		case 4:
			thisDoc->lineproplist[k].c1	=lua_tonumber(L,3);
			break;
		case 5:
			thisDoc->lineproplist[k].BdryFormat=(int)lua_tonumber(L,3);
			break;
		default:
			break;
	}
	
	return 0;
}

int CbeladrawDoc::lua_addpointprop(lua_State *L)
{

	CString m_nodename;
	double m_v, m_qp;
	int m_ptformat;

	m_nodename.Format("%s",lua_tostring(L,1));
	m_ptformat=(int) lua_tonumber(L,2);
	m_v=lua_tonumber(L,3);
	m_qp=lua_tonumber(L,4);

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CPointProp PProp;
	thisDoc->nodeproplist.Add(PProp);
		
	int k=thisDoc->nodeproplist.GetSize()-1;
	thisDoc->nodeproplist[k].PointName=m_nodename;
	thisDoc->nodeproplist[k].V=m_v;
	thisDoc->nodeproplist[k].qp=m_qp;

	return 0;
}

int CbeladrawDoc::lua_modpointprop(lua_State *L)
{
	CString PointName;
	int k,modprop;

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	// find the index of the material to modify;
	if (thisDoc->nodeproplist.GetSize()==0) return TRUE;
	PointName.Format("%s",lua_tostring(L,1));
	for(k=0;k<thisDoc->nodeproplist.GetSize();k++)
		if(PointName==thisDoc->nodeproplist[k].PointName) break;
	
	// get out of here if there's no matching material
	if(k==thisDoc->nodeproplist.GetSize()) return TRUE;

	modprop=(int) lua_tonumber(L,2);
	
	// now, modify the specified attribute...
	switch(modprop)
	{
		case 0:
			thisDoc->nodeproplist[k].PointName.Format("%s",lua_tostring(L,3));
			break;
		case 1:
			thisDoc->nodeproplist[k].V=lua_tonumber(L,3);
			break;
		case 2:
			thisDoc->nodeproplist[k].qp=lua_tonumber(L,3);
			break;
		default:
			break;
	}
	
	return 0;
}

int CbeladrawDoc::lua_addcircuitprop(lua_State *L)
{

	CString m_circname;
	double m_v, m_q;
	int m_circtype;

	m_circname=lua_tostring(L,1);
	m_v=lua_tonumber(L,2);
	m_q=lua_tonumber(L,3);
	m_circtype=(int) lua_tonumber(L,4);

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);


	CCircuit CProp;
	thisDoc->circproplist.Add(CProp);
		
	int k=thisDoc->circproplist.GetSize()-1;
	thisDoc->circproplist[k].CircName=m_circname;
	thisDoc->circproplist[k].CircType=m_circtype;
	thisDoc->circproplist[k].V=m_v;
	thisDoc->circproplist[k].q=m_q;

	return 0;
}

int CbeladrawDoc::lua_modcircprop(lua_State *L)
{
	CString CircName;
	int k,modprop;

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	// find the index of the material to modify;
	if (thisDoc->circproplist.GetSize()==0) return TRUE;
	CircName.Format("%s",lua_tostring(L,1));
	for(k=0;k<thisDoc->circproplist.GetSize();k++)
		if(CircName==thisDoc->circproplist[k].CircName) break;
	
	// get out of here if there's no matching circuit
	if(k==thisDoc->circproplist.GetSize()) return TRUE;

	modprop=(int) lua_tonumber(L,2);
	
	// now, modify the specified attribute...
	switch(modprop)
	{
		case 0:
			thisDoc->circproplist[k].CircName.Format("%s",lua_tostring(L,3));
			break;
		case 3:
			thisDoc->circproplist[k].CircType=(int) lua_tonumber(L,3);
			break;
		case 1:
			thisDoc->circproplist[k].V=lua_tonumber(L,3);
			break;
		case 2:
			thisDoc->circproplist[k].q=lua_tonumber(L,3);
			break;
		default:
			break;
	}
	
	return 0;
}

int CbeladrawDoc::lua_delcircuitprop(lua_State *L)
{
	CString name;
	name.Format("%s",lua_tostring(L,1));

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	for(int i=0;i<thisDoc->circproplist.GetSize();i++)
	{
		if (thisDoc->circproplist[i].CircName==name)
			thisDoc->circproplist.RemoveAt(i);

	}

	return 0;
}

int CbeladrawDoc::lua_delmatprop(lua_State *L)
{
	CString name;
	name.Format("%s",lua_tostring(L,1));

	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	for(int i=0;i<thisDoc->blockproplist.GetSize();i++)
	{
		if (thisDoc->blockproplist[i].BlockName==name)
			thisDoc->blockproplist.RemoveAt(i);

	}

	return 0;
}


int CbeladrawDoc::lua_delboundprop(lua_State *L)
{
	CString name;
	name.Format("%s",lua_tostring(L,1));

	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	for(int i=0;i<thisDoc->lineproplist.GetSize();i++)
	{
		if (thisDoc->lineproplist[i].BdryName==name)
		thisDoc->lineproplist.RemoveAt(i);
	}

	
	return 0;
}

int CbeladrawDoc::lua_delpointprop(lua_State *L)
{
	CString name;
	name.Format("%s",lua_tostring(L,1));
	CbeladrawDoc * thisDoc;CbeladrawView * theView;
	CPoint mypntstart;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	for(int i=0;i<thisDoc->nodeproplist.GetSize();i++)
	{
		if (thisDoc->nodeproplist[i].PointName==name)
		thisDoc->nodeproplist.RemoveAt(i);
	}

	return 0;
}

int CbeladrawDoc::lua_updatewindow(lua_State * L)
{

        CbeladrawDoc * thisDoc;
        CbeladrawView * theView;
        thisDoc=(CbeladrawDoc *)pFemmeDoc;
        POSITION pos;
        pos=thisDoc->GetFirstViewPosition();
        theView=(CbeladrawView *)thisDoc->GetNextView(pos);

        CDC tempDC;
        CDC *pDC=theView->GetDC();

        // erase background
        CBrush backBrush(theView->BackColor);
        CBrush* pOldBrush = pDC->SelectObject(&backBrush);
        CRect rect;
        pDC->GetClipBox(&rect);
        pDC->PatBlt(rect.left, rect.top, rect.Width(),
           rect.Height(), PATCOPY);
        pDC->SelectObject(pOldBrush);

        // force redraw
        theView->OnDraw(pDC);

        return 0;
}


int CbeladrawDoc::lua_savebitmap(lua_State * L)
{
        CbeladrawDoc * thisDoc;
        CbeladrawView * theView;
        thisDoc=(CbeladrawDoc *)pFemmeDoc;
        POSITION pos;
        pos=thisDoc->GetFirstViewPosition();
        theView=(CbeladrawView *)thisDoc->GetNextView(pos);
        CString filename;

        filename.Format("%s",lua_tostring(L,1));

    RECT r;
    CDC tempDC;
    CBitmap bitmap;
    CDC *pDC=theView->GetDC();

    theView->GetClientRect(&r);
    tempDC.CreateCompatibleDC(pDC);
    bitmap.CreateCompatibleBitmap(pDC, r.right, r.bottom);
    tempDC.SelectObject(&bitmap);

        tempDC.Rectangle(0,0,r.right,r.bottom);

        theView->OnDraw(&tempDC);

        PBITMAPINFO pbmi;

        pbmi=thisDoc->CreateBitmapInfoStruct(theView->m_hWnd,HBITMAP(bitmap));
        thisDoc->CreateBMPFile(theView->m_hWnd,filename.GetBuffer(1),pbmi,HBITMAP(bitmap),tempDC.m_hDC);

        return 0;
}


PBITMAPINFO CbeladrawDoc::CreateBitmapInfoStruct(HWND hwnd, HBITMAP hBmp)
{
    BITMAP bmp;
    PBITMAPINFO pbmi;
    WORD    cClrBits;

    // Retrieve the bitmap's color format, width, and height.
    if (!GetObject(hBmp, sizeof(BITMAP), (LPSTR)&bmp))
        {//errhandler("GetObject", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");
        }
    // Convert the color format to a count of bits.
    cClrBits = (WORD)(bmp.bmPlanes * bmp.bmBitsPixel);
    if (cClrBits == 1)
        cClrBits = 1;
    else if (cClrBits <= 4)
        cClrBits = 4;
    else if (cClrBits <= 8)
        cClrBits = 8;
    else if (cClrBits <= 16)
        cClrBits = 16;
    else if (cClrBits <= 24)
        cClrBits = 24;
    else cClrBits = 32;

    // Allocate memory for the BITMAPINFO structure. (This structure
    // contains a BITMAPINFOHEADER structure and an array of RGBQUAD
    // data structures.)

     if (cClrBits != 24)
         pbmi = (PBITMAPINFO) LocalAlloc(LPTR,
                    sizeof(BITMAPINFOHEADER) +
                    sizeof(RGBQUAD) * (1<< cClrBits));

     // There is no RGBQUAD array for the 24-bit-per-pixel format.

     else
         pbmi = (PBITMAPINFO) LocalAlloc(LPTR,
                    sizeof(BITMAPINFOHEADER));

    // Initialize the fields in the BITMAPINFO structure.

    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    pbmi->bmiHeader.biWidth = bmp.bmWidth;
    pbmi->bmiHeader.biHeight = bmp.bmHeight;
    pbmi->bmiHeader.biPlanes = bmp.bmPlanes;
    pbmi->bmiHeader.biBitCount = bmp.bmBitsPixel;
    if (cClrBits < 24)
        pbmi->bmiHeader.biClrUsed = (1<<cClrBits);

    // If the bitmap is not compressed, set the BI_RGB flag.
    pbmi->bmiHeader.biCompression = BI_RGB;

    // Compute the number of bytes in the array of color
    // indices and store the result in biSizeImage.
    // For Windows NT/2000, the width must be DWORD aligned unless
    // the bitmap is RLE compressed. This example shows this.
    // For Windows 95/98, the width must be WORD aligned unless the
    // bitmap is RLE compressed.
    pbmi->bmiHeader.biSizeImage = ((pbmi->bmiHeader.biWidth * cClrBits +31) & ~31) /8
                                  * pbmi->bmiHeader.biHeight;
    // Set biClrImportant to 0, indicating that all of the
    // device colors are important.
     pbmi->bmiHeader.biClrImportant = 0;
     return pbmi;
 }


void CbeladrawDoc::CreateBMPFile(HWND hwnd, LPTSTR pszFile, PBITMAPINFO pbi,
                  HBITMAP hBMP, HDC hDC)
 {
     HANDLE hf;                 // file handle
    BITMAPFILEHEADER hdr;       // bitmap file-header
    PBITMAPINFOHEADER pbih;     // bitmap info-header
    LPBYTE lpBits;              // memory pointer
    DWORD dwTotal;              // total count of bytes
    DWORD cb;                   // incremental count of bytes
    BYTE *hp;                   // byte pointer
    DWORD dwTmp;

    pbih = (PBITMAPINFOHEADER) pbi;
    lpBits = (LPBYTE) GlobalAlloc(GMEM_FIXED, pbih->biSizeImage);

    if (!lpBits)
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");
//              errhandler("GlobalAlloc", hwnd);

    // Retrieve the color table (RGBQUAD array) and the bits
    // (array of palette indices) from the DIB.
    if (!GetDIBits(hDC, hBMP, 0, (WORD) pbih->biHeight, lpBits, pbi,
        DIB_RGB_COLORS))
    {
    //    errhandler("GetDIBits", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

        }

    // Create the .BMP file.
    hf = CreateFile(pszFile,
                   GENERIC_READ | GENERIC_WRITE,
                   (DWORD) 0,
                    NULL,
                   CREATE_ALWAYS,
                   FILE_ATTRIBUTE_NORMAL,
                   (HANDLE) NULL);
    if (hf == INVALID_HANDLE_VALUE)
    {//    errhandler("CreateFile", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

        }
        hdr.bfType = 0x4d42;        // 0x42 = "B" 0x4d = "M"
    // Compute the size of the entire file.
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
                 pbih->biSize + pbih->biClrUsed
                 * sizeof(RGBQUAD) + pbih->biSizeImage);
    hdr.bfReserved1 = 0;
    hdr.bfReserved2 = 0;

    // Compute the offset to the array of color indices.
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
                    pbih->biSize + pbih->biClrUsed
                    * sizeof (RGBQUAD);

    // Copy the BITMAPFILEHEADER into the .BMP file.
    if (!WriteFile(hf, (LPVOID) &hdr, sizeof(BITMAPFILEHEADER),
        (LPDWORD) &dwTmp,  NULL))
    {
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

        //      errhandler("WriteFile", hwnd);
    }

    // Copy the BITMAPINFOHEADER and RGBQUAD array into the file.
    if (!WriteFile(hf, (LPVOID) pbih, sizeof(BITMAPINFOHEADER)
                  + pbih->biClrUsed * sizeof (RGBQUAD),
                  (LPDWORD) &dwTmp, ( NULL)))
//        errhandler("WriteFile", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

    // Copy the array of color indices into the .BMP file.
    dwTotal = cb = pbih->biSizeImage;
    hp = lpBits;
    if (!WriteFile(hf, (LPSTR) hp, (int) cb, (LPDWORD) &dwTmp,NULL))
//           errhandler("WriteFile", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

    // Close the .BMP file.
     if (!CloseHandle(hf))
//           errhandler("CloseHandle", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

    // Free memory.
    GlobalFree((HGLOBAL)lpBits);
}


int CbeladrawDoc::lua_saveWMF(lua_State * L)
{

    CbeladrawDoc * thisDoc;
    CbeladrawView * theView;
    thisDoc=(CbeladrawDoc *)pFemmeDoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbeladrawView *)thisDoc->GetNextView(pos);


    CString filename;

    filename.Format("%s",lua_tostring(L,1));

    RECT r;
    CDC tempDC;
    CDC *pDC=theView->GetDC();

    CMetaFileDC Meta;
    CRgn R;

    Meta.CreateEnhanced(NULL,NULL,NULL,NULL);
    theView->GetClientRect(&r);
    R.CreateRectRgnIndirect(&r);
    Meta.SelectClipRgn(&R);
    theView->OnDraw(&Meta);
    HENHMETAFILE hMeta=Meta.CloseEnhanced();

    CopyEnhMetaFile(hMeta,filename);


	return 0;
}

int CbeladrawDoc::lua_ERROR(lua_State *L)
{

	CString errmsg;
	errmsg.Format("%s",lua_tostring(L,1));


	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	// Somthing went wrong in lua execution
	// Windows dosn't have stdout so lets afxmessagebox it

	AfxMessageBox(errmsg);
	
	return 0;
}

int CbeladrawDoc::lua_messagebox(lua_State *L)
{

	CString errmsg;
	errmsg.Format("%s",lua_tostring(L,1));


	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	AfxMessageBox(errmsg,MB_ICONINFORMATION);
	
	return 0;
}

int CbeladrawDoc::lua_afxpause(lua_State * L)
{
	AfxMessageBox("LUA pause");

	return 0;
}

int CbeladrawDoc::lua_promptbox(lua_State *L)
{
	CPromptBox dlg;

	int n=lua_gettop(L);
	if(n>0) dlg.mytitle = lua_tostring(L,1);
	dlg.DoModal();
	lua_pushstring(L,dlg.instring);

	return TRUE;
}


int CbeladrawDoc::lua_hidegrid(lua_State * L)
{
	
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	theView->GridFlag=FALSE;
	MMnu->CheckMenuItem(ID_SHOW_GRID, MF_UNCHECKED);
	tc->CheckButton(ID_SHOW_GRID,FALSE);
	theView->InvalidateRect(NULL);

	return 0;
}


int CbeladrawDoc::lua_showgrid(lua_State * L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	theView->GridFlag=TRUE;
	MMnu->CheckMenuItem(ID_SHOW_GRID, MF_CHECKED);
	tc->CheckButton(ID_SHOW_GRID,TRUE);
	theView->InvalidateRect(NULL);

	return 0;
}


int CbeladrawDoc::lua_gridsnap(lua_State * L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CString temp;
	temp.Format("%s",lua_tostring(L,1));
	temp.MakeLower();

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	if(temp=="off"){
		theView->SnapFlag=FALSE;
		MMnu->CheckMenuItem(ID_SNAP_GRID, MF_UNCHECKED);
		tc->CheckButton(ID_SNAP_GRID,FALSE);
	}
	else{
		theView->SnapFlag=TRUE;
		MMnu->CheckMenuItem(ID_SNAP_GRID, MF_CHECKED);
		tc->CheckButton(ID_SNAP_GRID,TRUE);
	}
	

		if (temp !="on" && temp !="off")
	{
		CString msg="Unknown option for grid snap";
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}


	return 0;
}


int CbeladrawDoc::lua_setgrid(lua_State * L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);

	CString temp;
	int coords=0;
	double gridsize;

	gridsize=lua_tonumber(L,1);
	temp.Format("%s",lua_tostring(L,2));
	temp.MakeLower();

	if (temp=="cart")  coords=0;
	if (temp=="polar") coords=1;

		if (temp !="cart" && temp !="polar")
	{
		CString msg="Unknown option for set grid";
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}


	theView->GridSize=gridsize;
	thisDoc->Coords=coords;
	theView->InvalidateRect(NULL);

	return 0;
}

int CbeladrawDoc::lua_shownames(lua_State * L)
{
	CbeladrawDoc * thisDoc;
	CbeladrawView * theView;
	thisDoc=(CbeladrawDoc *)pFemmeDoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbeladrawView *)thisDoc->GetNextView(pos);


	int flg=(int)lua_tonumber(L,1);
	if (flg!=0) flg=1;
	theView->ShowNames=flg;
	theView->InvalidateRect(NULL);

	return 0;
}