#include "stdafx.h"
#include "MainFrm.h"
#include "beladraw.h"
#include <afxtempl.h>
#include "beladrawDoc.h"
#include "beladrawView.h"
#include <process.h>

extern BOOL bIsLua;
extern lua_State *lua;

void CbeladrawView::lnuMakeMesh()
{
	OnMakeMesh();
}

void CbeladrawView::lnu_purge_mesh()
{
	OnPurgemesh();
}

void CbeladrawView::lnu_show_mesh()
{
	OnShowMesh();
}

void CbeladrawView::lnu_analyze(int bShow)
{
	bIsLua=bShow+1;
	OnMenuAnalyze();
}

void CbeladrawView::lnu_runpost(CString scriptfilename,int bHide)
{
	CbeladrawDoc *TheDoc = GetDocument();

    ASSERT_VALID(TheDoc);
    CString pn = TheDoc->GetPathName();
    if (pn.GetLength()==0){
		AfxMessageBox("No results to display",MB_OK | MB_ICONEXCLAMATION,0);
        return;
    }

    CString rootname= "\"" + pn.Left(pn.ReverseFind('.'))+".res\"";
    char CommandLine[512];

    sprintf(CommandLine,"\"%sbelaview.exe\" %s -lua-script=%s",BinDir,rootname,scriptfilename);

    STARTUPINFO StartupInfo2 = {0};
    PROCESS_INFORMATION ProcessInfo2;
    StartupInfo2.cb = sizeof(STARTUPINFO);
	if (bHide==TRUE){
		StartupInfo2.dwFlags = STARTF_USESHOWWINDOW;
		StartupInfo2.wShowWindow = SW_MINIMIZE;
	}
    if (CreateProcess(NULL,CommandLine, NULL, NULL, FALSE,
            0, NULL, NULL, &StartupInfo2, &ProcessInfo2))
	{
		// block our code until return
		DWORD ExitCode;			
		TheDoc->hProc=ProcessInfo2.hProcess;
		do{
			GetExitCodeProcess(ProcessInfo2.hProcess,&ExitCode);
			TheDoc->line_hook(lua,NULL);	
		} while(ExitCode==STILL_ACTIVE);
		TheDoc->hProc=NULL;
    }
    else
    {
        AfxMessageBox("Problem executing the postprocessor");
        return;
    }
}


void CbeladrawView::lua_zoomnatural()
{
	OnZoomNatural();
}

void CbeladrawView::lua_zoomout()
{
	OnZoomOut();
}

void CbeladrawView::lua_zoomin()
{
	OnZoomIn();
}
