// MatLib.cpp : implementation file
//

#include "stdafx.h"
#include "beladraw.h"
#include "beladrawDoc.h"
#include "MatLib.h"
#include "MatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatLib dialog


CMatLib::CMatLib(CWnd* pParent /*=NULL*/)
	: CDialog(CMatLib::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMatLib)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMatLib::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatLib)
	DDX_Control(pDX, IDC_INMODEL, m_inmodel);
	DDX_Control(pDX, IDC_INLIBRARY, m_inlibrary);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMatLib, CDialog)
	//{{AFX_MSG_MAP(CMatLib)
	ON_BN_CLICKED(IDC_LIB_MODIFY, OnLibModify)
	ON_BN_CLICKED(IDC_LIB_REMOVE, OnLibRemove)
	ON_BN_CLICKED(IDC_TOMODEL, OnToModel)
	ON_BN_CLICKED(IDC_TOLIBRARY, OnToLibrary)
	ON_BN_CLICKED(IDC_MODEL_DEL, OnModelDel)
	ON_BN_CLICKED(IDC_NEW_LIB_ENTRY, OnNewLibEntry)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatLib message handlers

void CMatLib::OnLibModify() 
{
	// TODO: Add your control notification handler code here
		CArray <CMaterialProp, CMaterialProp&> &blockproplist=pDoc->blockproplist;
		CMatDlg zDlg;

		if (LibProps.GetSize()==0) return;
		int k=m_inlibrary.GetCurSel();
		if (k==CB_ERR) return;

		zDlg.m_ex=LibProps[k].ex;
		zDlg.m_ey=LibProps[k].ey;
		zDlg.m_qv=LibProps[k].qv;
		zDlg.m_BlockName=LibProps[k].BlockName;
		
		if(pDoc->ProblemType==0){
			zDlg.m_mu1label="x";
			zDlg.m_mu2label="y";
		}
		else{
			zDlg.m_mu1label="r";
			zDlg.m_mu2label="z";
		}

		if(zDlg.DoModal()==IDOK){
			LibProps[k].BlockName=zDlg.m_BlockName;
			LibProps[k].ex=zDlg.m_ex;
			LibProps[k].ey=zDlg.m_ey;
			LibProps[k].qv=zDlg.m_qv;
			
			m_inlibrary.InsertString(k,zDlg.m_BlockName);
			m_inlibrary.DeleteString(k+1);
			m_inlibrary.SetCurSel(k);

		}
}

void CMatLib::OnLibRemove() 
{
	// TODO: Add your control notification handler code here
	
		int k=m_inlibrary.GetCurSel();
		if((k!=CB_ERR) && (LibProps.GetSize()!=0))
		{	
			LibProps.RemoveAt(k);
			m_inlibrary.DeleteString(k);
			m_inlibrary.SetCurSel(0);
		}
}

void CMatLib::OnToModel() 
{
	// TODO: Add your control notification handler code here
	CArray <CMaterialProp, CMaterialProp&> &blockproplist=pDoc->blockproplist;
	int k=m_inlibrary.GetCurSel();
	if (k==CB_ERR) return;
	int i=blockproplist.GetSize();
	int j;

	// check to see if the property has already been included;
	for(j=0;j<i;j++)
		if(blockproplist[j].BlockName==LibProps[k].BlockName){
			AfxMessageBox("Cannot add this property; a property\nwith this name is already in the model");
			return;
		}

	blockproplist.Add(LibProps[k]);
	m_inmodel.AddString(LibProps[k].BlockName);
	m_inmodel.SetCurSel(i);
}

void CMatLib::OnToLibrary() 
{
		// TODO: Add your control notification handler code here
	CArray <CMaterialProp, CMaterialProp&> &blockproplist=pDoc->blockproplist;
	int k=m_inmodel.GetCurSel();
	if (k==CB_ERR) return;
	int i=LibProps.GetSize();
	int j;

	// check to see if the property has already been included;
	for(j=0;j<i;j++)
		if(blockproplist[k].BlockName==LibProps[j].BlockName){
			AfxMessageBox("Cannot add this property; a property\nwith this name is already in the library");
			return;
		}

	LibProps.Add(blockproplist[k]);
	m_inlibrary.AddString(blockproplist[k].BlockName);
	m_inlibrary.SetCurSel(i);
	
}

void CMatLib::OnModelDel() 
{
	// TODO: Add your control notification handler code here
		CArray <CMaterialProp, CMaterialProp&> &blockproplist=pDoc->blockproplist;
		int k=m_inmodel.GetCurSel();
		if((k!=CB_ERR) && (blockproplist.GetSize()!=0))
		{	
			blockproplist.RemoveAt(k);
			m_inmodel.DeleteString(k);
			m_inmodel.SetCurSel(0);
		}
}

BOOL CMatLib::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CArray<CMaterialProp,CMaterialProp&> &blockproplist=pDoc->blockproplist;
	int i,k;

	CString LibName=BinDir+"statlib.dat";

	FILE *fp;
	CMaterialProp MProp;
	char s[1024],q[1024];
	char *v;
	// Put Model's properties into the InModel edit box;
	for(i=0;i<blockproplist.GetSize();i++)
		m_inmodel.AddString(blockproplist[i].BlockName);
	m_inmodel.SetCurSel(0);

	// read in materials library;
	LibProps.RemoveAll();

	if ((fp=fopen(LibName,"rt"))==NULL) return TRUE;

	while (fgets(s,1024,fp)!=NULL)
	{ 
		sscanf(s,"%s",q);

		// Block Properties;
		if( _strnicmp(q,"<beginblock>",12)==0){	
			MProp.BlockName="New Material";
			MProp.ex=1.;
			MProp.ey=1.;
			MProp.qv=0.;
			q[0]=NULL;
		}

		if( _strnicmp(q,"<blockname>",10)==0){
			v=StripKey(s);
			k=strlen(v);
			for(i=0;i<k;i++)
				if(v[i]=='\"'){
					v=v+i+1;
					i=k;
				}
			k=strlen(v);
			if(k>0) for(i=k-1;i>=0;i--){
				if(v[i]=='\"'){
					v[i]=0;
					i=-1;
				}
			}
			MProp.BlockName=v;
			q[0]=NULL;
		}

		if( _strnicmp(q,"<ex>",4)==0){
		   v=StripKey(s);
		   sscanf(v,"%lf",&MProp.ex);
		   q[0]=NULL;
		}
		
		if( _strnicmp(q,"<ey>",4)==0){
		   v=StripKey(s);
		   sscanf(v,"%lf",&MProp.ey);
		   q[0]=NULL;
		}	

		if( _strnicmp(q,"<qv>",4)==0){
		   v=StripKey(s);
		   sscanf(v,"%lf",&MProp.qv);
		   q[0]=NULL;
		}	

		if( _strnicmp(q,"<endblock>",9)==0){
			LibProps.Add(MProp);
			q[0]=NULL;
		}
	}

	fclose(fp);

	// Put Library's properties into the InLibrary edit box;
	for(i=0;i<LibProps.GetSize();i++)
		m_inlibrary.AddString(LibProps[i].BlockName);
	m_inlibrary.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMatLib::OnOK() 
{
	int i;

	CString LibName=BinDir+"statlib.dat";

	FILE *fp;

	if ((fp=fopen(LibName,"wt"))==NULL) return;
	for(i=0;i<LibProps.GetSize();i++)
	{
		fprintf(fp,"<BeginBlock>\n");
		fprintf(fp,"<BlockName> = \"%s\"\n",LibProps[i].BlockName);
		fprintf(fp,"<ex> = %.17g\n",LibProps[i].ex);
		fprintf(fp,"<ey> = %.17g\n",LibProps[i].ey);
		fprintf(fp,"<qv> = %.17g\n",LibProps[i].qv);
		fprintf(fp,"<EndBlock>\n\n");
	}
	fclose(fp);
	
	CDialog::OnOK();


}

void CMatLib::OnNewLibEntry() 
{
	// TODO: Add your control notification handler code here
	CMaterialProp MProp;
	int k=LibProps.GetSize();
	LibProps.Add(MProp);
	m_inlibrary.AddString(LibProps[k].BlockName);
	m_inlibrary.SetCurSel(k);
	OnLibModify();
}
