// OpBlkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "beladraw.h"
#include "beladrawDoc.h"
#include "OpBlkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpBlkDlg dialog


COpBlkDlg::COpBlkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpBlkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpBlkDlg)
	m_sidelength = 0.0;
	m_ingroup = 0;
	//}}AFX_DATA_INIT
}


void COpBlkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpBlkDlg)
	DDX_Control(pDX, IDC_AUTOMESHCHECK, m_automesh);
	DDX_Control(pDX, IDC_ACKBLK, m_ackblk);
	DDX_Text(pDX, IDC_SIDELENGTH, m_sidelength);
	DDX_Text(pDX, IDC_BLKGROUP, m_ingroup);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SIDELENGTH, m_IDC_sidelength);
	DDX_Control(pDX, IDC_BLKGROUP, m_IDC_ingroup);
}


BEGIN_MESSAGE_MAP(COpBlkDlg, CDialog)
	//{{AFX_MSG_MAP(COpBlkDlg)
	ON_CBN_SELCHANGE(IDC_ACKBLK, OnSelchangeAckblk)
	ON_BN_CLICKED(IDC_AUTOMESHCHECK, OnAutomeshcheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpBlkDlg message handlers

void COpBlkDlg::OnOK() 
{
	// TODO: Add extra validation here
	cursel=m_ackblk.GetCurSel();
	CDialog::OnOK();
}

BOOL COpBlkDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CArray<CMaterialProp,CMaterialProp&> &blockproplist=*pblockproplist;
	CArray<CCircuit, CCircuit&> &circproplist=*pcircproplist;

	int i;

	// TODO: Add extra initialization here
	m_ackblk.AddString("<None>");
	m_ackblk.AddString("<No Mesh>");
	for(i=0;i<blockproplist.GetSize();i++)
		m_ackblk.AddString(blockproplist[i].BlockName);
	m_ackblk.SetCurSel(cursel);
	OnSelchangeAckblk();

	if(m_sidelength==0) m_automesh.SetCheck(TRUE);
	else m_automesh.SetCheck(FALSE);
	OnAutomeshcheck();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COpBlkDlg::OnSelchangeAckblk() 
{
	CArray<CMaterialProp,CMaterialProp&> &blockproplist=*pblockproplist;
	BOOL bEnable=FALSE;

	cursel=m_ackblk.GetCurSel();
	SendDlgItemMessage(
		IDC_MAGDIR, // identifier of control
		WM_ENABLE,       // message to send
		(WPARAM) bEnable,  // first message parameter
		(LPARAM) 0   // second message parameter
	);
}

void COpBlkDlg::OnAutomeshcheck() 
{
	// TODO: Add your control notification handler code here
	int k=m_automesh.GetCheck();
	if (k==TRUE) k=FALSE;
	else k=TRUE;

	SendDlgItemMessage(
		IDC_SIDELENGTH, // identifier of control
		WM_ENABLE,       // message to send
		(WPARAM) k,  // first message parameter
		(LPARAM) 0   // second message parameter
	);
	if (k==FALSE){
		m_sidelength=0;
		SetDlgItemText(IDC_SIDELENGTH, "0" );
	}
}
