// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include <afx.h>
#include <afxtempl.h>
#include "complex.h"
#include "problem.h"
#include "belaview.h"
#include "xyplot.h"
#include "MainFrm.h"
#include "belaviewDoc.h"

extern int m_luaWindowStatus;
extern BOOL bIsLua;
extern lua_State *lua;

BOOL bNoClose;
extern BOOL bNoClose;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_PT_PROP, OnPtProp)
	ON_COMMAND(ID_SHOW_TBAR, OnShowTbar)
	ON_WM_INITMENU()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	// Global help commands
//	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
//	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
//	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
//	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
//	ID_INDICATOR_CAPS,
//	ID_INDICATOR_NUM,
//	ID_INDICATOR_SCRL,
};

static UINT BASED_CODE arToolButtons[]=
{
	ID_MENU_POINT,
	ID_MENU_CONTOUR,
	ID_MENU_AREA,
		ID_SEPARATOR,
	ID_SHOW_GRID,
	ID_SNAP_GRID,
	ID_SET_GRID,
		ID_SEPARATOR,
	ID_MENU_PLOT,
	ID_MENU_INTEGRATE,
		ID_SEPARATOR,
	ID_SHOW_MESH,
	ID_CPLOT,
	ID_DPLOT,
	ID_VPLOT,
		ID_SEPARATOR,
	ID_ZOOM_IN,
	ID_ZOOM_OUT,
	ID_ZOOM_NATURAL,
	ID_ZOOM_WINDOW,
	ID_PAN_LEFT,
	ID_PAN_UP,
	ID_PAN_DOWN,
	ID_PAN_RIGHT,
};
/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	bNoClose=FALSE;
}

CMainFrame::~CMainFrame()
{

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// force the status bar to use a more readable font size
	LOGFONT lf;                        // Used to create the CFont.
    memset(&lf, 0, sizeof(LOGFONT));   // Clear out structure.
	lf.lfHeight = 16;                  
	strcpy(lf.lfFaceName, "MS Sans Serif");     
	m_StatusBarFont.CreateFontIndirect(&lf);    // Create the font.
	m_wndStatusBar.SetFont(&m_StatusBarFont);
  
	// create output window;
	EnableDocking(0);
	m_dlgBar.Create(this,IDD_OUTBOX,CBRS_TOP,IDD_OUTBOX);
	m_dlgBar.SetWindowText("Belaview Output");
	m_dlgBar.EnableDocking(0);
	CRect rc;
	GetClientRect(&rc);
	ClientToScreen(&rc);
	CPoint p=rc.BottomRight();
	p.x-=175; p.y-=300;
	if (m_luaWindowStatus!=SW_MINIMIZE) FloatControlBar(&m_dlgBar,p);
	
	// flash up title;
	{
		char s[80];
		sprintf(s,"belaview 1.0");
		m_dlgBar.SetDlgItemText(IDC_LINE1,s);
		sprintf(s,"Electrostatics finite element postprocessor");
		m_dlgBar.SetDlgItemText(IDC_LINE2,s);
		sprintf(s,"Copyright 1998-2003");
		m_dlgBar.SetDlgItemText(IDC_LINE4,s);
		sprintf(s,"David Meeker");
		m_dlgBar.SetDlgItemText(IDC_LINE5,s);
		sprintf(s,"dmeeker@ieee.org");
		m_dlgBar.SetDlgItemText(IDC_LINE6,s);
		sprintf(s,"http://femm.berlios.de");
		m_dlgBar.SetDlgItemText(IDC_LINE7,s);
		sprintf(s," ");
		m_dlgBar.SetDlgItemText(IDC_LINE8,s);
		sprintf(s,"");
		m_dlgBar.SetDlgItemText(IDC_LINE9,s);
		sprintf(s,"");
		m_dlgBar.SetDlgItemText(IDC_LINE10,s);
	}

	// Create a toolbar
	m_toolBar.Create(this);
	m_toolBar.SetWindowText("FEMM Postprocessor Tools");
	m_toolBar.LoadBitmap(IDB_TOOLS);
	m_toolBar.SetButtons(arToolButtons,
		sizeof(arToolButtons)/sizeof(UINT));
	m_toolBar.EnableDocking(CBRS_ALIGN_TOP);
	EnableDocking(CBRS_ALIGN_TOP);
	DockControlBar( &m_toolBar );
	UINT nOldStyle=m_toolBar.GetBarStyle();
	m_toolBar.SetBarStyle(nOldStyle | CBRS_TOOLTIPS | CBRS_FLYBY);
	
	return 0;

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnPtProp() 
{
	if( (m_dlgBar.GetStyle() & WS_VISIBLE) != 0 ){
		ShowControlBar(&m_dlgBar,FALSE,FALSE);
	}
	else{
		ShowControlBar(&m_dlgBar,TRUE,FALSE);
	}
}

void CMainFrame::OnShowTbar() 
{
	if( (m_toolBar.GetStyle() & WS_VISIBLE) != 0 ){
		ShowControlBar(&m_toolBar,FALSE,FALSE);
	}
	else{
		ShowControlBar(&m_toolBar,TRUE,FALSE);
	}
}

void CMainFrame::OnInitMenu(CMenu* pMenu) 
{
	CFrameWnd::OnInitMenu(pMenu);

	if( (m_toolBar.GetStyle() & WS_VISIBLE) != 0 ){
		// make sure that toolbar entry is checked
		pMenu->CheckMenuItem(ID_SHOW_TBAR, MF_CHECKED);
	}
	else{
		// make sure that toolbar entry is not checked
		pMenu->CheckMenuItem(ID_SHOW_TBAR, MF_UNCHECKED);
	}
	
	if( (m_dlgBar.GetStyle() & WS_VISIBLE) != 0 ){
		// make sure that toolbar entry is checked
		pMenu->CheckMenuItem(ID_PT_PROP, MF_CHECKED);
	}
	else{
		// make sure that toolbar entry is not checked
		pMenu->CheckMenuItem(ID_PT_PROP, MF_UNCHECKED);
	}	
	
	CbelaviewDoc *pFemmviewDoc=(CbelaviewDoc *) GetActiveDocument( );
    if((pFemmviewDoc->LuaConsole.GetStyle() & WS_VISIBLE) != 0 )
		pMenu->CheckMenuItem(ID_VIEW_LUACONSOLE, MF_CHECKED);
	else pMenu->CheckMenuItem(ID_VIEW_LUACONSOLE, MF_UNCHECKED);
}


void CMainFrame::OnClose() 
{
	if (bIsLua!=FALSE){
		bIsLua=FALSE;
		PostMessage(WM_CLOSE);
		lua_error(lua,NULL);
	}
 	if (!bNoClose) CFrameWnd::OnClose();
}
