

#include "stdafx.h"
#include <afx.h>
#include <afxtempl.h>
#include "complex.h"
#include "problem.h"
#include "belaview.h"
#include "xyplot.h"
#include "MainFrm.h"
#include "belaviewDoc.h"
#include "belaviewview.h"
#include "ptloc.h"
#include "windows.h" //necessary for bitmap saving
#include "lua.h"
#include "mycommandlineinfo.h"
#include "promptbox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

lua_State * lua;
BOOL bIsLua;
CString luascriptname;
CbelaviewDoc * pFemmviewdoc;
BOOL lua_byebye;
int        m_luaWindowStatus;

extern lua_State * lua;
extern BOOL bIsLua;
extern int m_luaWindowStatus;
//-------------------Lua Extensions-------------------------

void CbelaviewDoc::initalise_lua()
{
	// lua initalisation as called from doc constructor
	luafired=false;
	bIsLua=FALSE;
	lua=lua_open(4096);
    lua_baselibopen(lua);
	lua_strlibopen(lua);
	lua_mathlibopen(lua);
	lua_iolibopen(lua);

	// add lua error callback
	lua_register(lua,"_ALERT",lua_ERROR);

	// use a messagebox to display errors
	lua_register(lua,"getpointvalues",lua_getpointvals);
	lua_register(lua,"exitpost",lua_exitpost);
	lua_register(lua,"addcontour",lua_addcontour);
	lua_register(lua,"clearcontour",lua_clearcontour);
	lua_register(lua,"lineintegral",lua_lineintegral);
	lua_register(lua,"selectblock",lua_selectblock);
	lua_register(lua,"groupselectblock",lua_groupselectblock);
	lua_register(lua,"clearblock",lua_clearblock);
	lua_register(lua,"blockintegral",lua_blockintegral);
	lua_register(lua,"pause",lua_afxpause);
	lua_register(lua,"zoomnatural",lua_zoomnatural);
	lua_register(lua,"zoomin",lua_zoomin);
	lua_register(lua,"zoomout",lua_zoomout);
	lua_register(lua,"zoom",lua_zoom);
	lua_register(lua,"showgrid",lua_showgrid);
	lua_register(lua,"hidegrid",lua_hidegrid);
	lua_register(lua,"gridsnap",lua_gridsnap);
	lua_register(lua,"setgrid",lua_setgrid);
	lua_register(lua,"showmesh",lua_showmesh);
	lua_register(lua,"hidemesh",lua_hidemesh);
	lua_register(lua,"hidedensityplot",lua_hidedensity);
	lua_register(lua,"showdensityplot",lua_showdensity);
	lua_register(lua,"hidecontourplot",lua_hidecountour);
	lua_register(lua,"showcontourplot",lua_showcountour);
	lua_register(lua,"showvectorplot" ,lua_vectorplot);
	lua_register(lua,"smooth",lua_smoothing);
	lua_register(lua,"showpoints",lua_showpoints);
	lua_register(lua,"hidepoints",lua_hidepoints);
	lua_register(lua,"shownames",lua_shownames);
	lua_register(lua,"getprobleminfo",lua_getprobleminfo);
	lua_register(lua,"savebitmap",lua_savebitmap);
	lua_register(lua,"getconductorproperties",lua_getcircuitprops);
	lua_register(lua,"savemetafile",lua_saveWMF);
    lua_register(lua,"refreshview",lua_refreshview);
	lua_register(lua,"selectpoint",lua_selectline);
    lua_register(lua,"showpointprops",lua_showpointprops);
    lua_register(lua,"hidepointprops",lua_hidepointprops);
	lua_register(lua,"messagebox",lua_messagebox);
	lua_register(lua,"seteditmode",lua_seteditmode);
	lua_register(lua,"bendcontour",lua_bendcontour);
	lua_register(lua,"makeplot",lua_makeplot);
	lua_register(lua,"selectconductor",lua_selectconductor);

	// compatibility with alternate lua function naming convention
	lua_register(lua,"get_point_values",lua_getpointvals);
	lua_register(lua,"exit_post",lua_exitpost);
	lua_register(lua,"add_contour",lua_addcontour);
	lua_register(lua,"clear_contour",lua_clearcontour);
	lua_register(lua,"line_integral",lua_lineintegral);
	lua_register(lua,"select_block",lua_selectblock);
	lua_register(lua,"group_select_block",lua_groupselectblock);
	lua_register(lua,"clear_block",lua_clearblock);
	lua_register(lua,"block_integral",lua_blockintegral);
	lua_register(lua,"zoom_natural",lua_zoomnatural);
	lua_register(lua,"zoom_in",lua_zoomin);
	lua_register(lua,"zoom_out",lua_zoomout);
	lua_register(lua,"show_grid",lua_showgrid);
	lua_register(lua,"hide_grid",lua_hidegrid);
	lua_register(lua,"show_mesh",lua_showmesh);
	lua_register(lua,"hide_mesh",lua_hidemesh);
	lua_register(lua,"hide_density_plot",lua_hidedensity);
	lua_register(lua,"show_density_plot",lua_showdensity);
	lua_register(lua,"hide_contour_plot",lua_hidecountour);
	lua_register(lua,"show_contour_plot",lua_showcountour);
	lua_register(lua,"show_points",lua_showpoints);
	lua_register(lua,"hide_points",lua_hidepoints);
	lua_register(lua,"grid_snap",lua_gridsnap);
	lua_register(lua,"set_grid",lua_setgrid);
	lua_register(lua,"get_problem_info",lua_getprobleminfo);
	lua_register(lua,"save_bitmap",lua_savebitmap);
	lua_register(lua,"get_conductor_properties",lua_getcircuitprops);
	lua_register(lua,"save_metafile",lua_saveWMF);
    lua_register(lua,"refresh_view",lua_refreshview);
	lua_register(lua,"select_point",lua_selectline);
    lua_register(lua,"show_point_props",lua_showpointprops);
    lua_register(lua,"hide_point_props",lua_hidepointprops);
	lua_register(lua,"set_edit_mode",lua_seteditmode);
	lua_register(lua,"message_box",lua_messagebox);
	lua_register(lua,"bend_contour",lua_bendcontour);
	lua_register(lua,"prompt",lua_promptbox);
	lua_register(lua,"make_plot",lua_makeplot);
	lua_register(lua,"select_conductor",lua_selectconductor);
	lua_register(lua,"show_names",lua_shownames);
	lua_register(lua,"show_vector_plot",lua_vectorplot);

	lua_setlinehook(lua,line_hook);

	pFemmviewdoc=this;
	CMyCommandLineInfo cmdInfo;
    AfxGetApp()->ParseCommandLine(cmdInfo);

    CWnd * pwin;
    pwin=AfxGetApp()->GetMainWnd();

	LuaConsole.Create(IDD_LUACONSOLE);
	if ((d_luaconsole!=FALSE) && (m_luaWindowStatus!=SW_MINIMIZE)) 
		LuaConsole.ShowWindow(SW_SHOW);

	// define some initial variables
	lua_dostring(lua,"eo=8.85418781762e-12\n");
}

void CbelaviewDoc::line_hook(lua_State *L, lua_Debug *ar)
{

	BOOL bIllegal=FALSE;
    MSG msg;

	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) 
	{ 
		if ((msg.message == WM_KEYDOWN) && (msg.wParam == VK_PAUSE))
		{
			bIsLua=FALSE;
			bIllegal=TRUE;
			MessageBeep(MB_ICONEXCLAMATION);
			lua_error(L,NULL);		
		}
		if(msg.message==WM_KEYDOWN) bIllegal=TRUE;

		// should these be blocked?
//		if(msg.message==WM_RBUTTONDOWN) bIllegal=TRUE;
//		if(msg.message==WM_LBUTTONDOWN) bIllegal=TRUE;	
//		if(msg.message==WM_LBUTTONUP) bIllegal=TRUE;
		if(msg.message==WM_LBUTTONDBLCLK) bIllegal=TRUE;
		if(msg.message==WM_RBUTTONDBLCLK) bIllegal=TRUE;

		// side-track all commands
		if(msg.message==WM_COMMAND)
		{
			UINT wID=LOWORD(msg.wParam);  
			if(wID==ID_FILE_OPEN) bIllegal=TRUE;
			if(wID==ID_FILE_NEW) bIllegal=TRUE;
			if(wID==ID_FILE_SAVE) bIllegal=TRUE;
			if(wID==ID_FILE_SAVE_AS) bIllegal=TRUE;
			if(wID==ID_APP_EXIT) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE1) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE2) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE3) bIllegal=TRUE;
			if(wID==ID_FILE_MRU_FILE4) bIllegal=TRUE;
			if(wID==ID_FILE_OPEN_LUA_SCRIPT) bIllegal=TRUE;
			if(wID==ID_ZOOM_IN) bIllegal=TRUE; 
			if(wID==ID_SNAP_GRID) bIllegal=TRUE; 
			if(wID==ID_SHOW_MESH) bIllegal=TRUE; 
			if(wID==ID_SHOW_GRID) bIllegal=TRUE; 
			if(wID==ID_SET_GRID) bIllegal=TRUE; 
			if(wID==ID_CPLOT) bIllegal=TRUE; 
			if(wID==ID_DPLOT) bIllegal=TRUE; 
			if(wID==ID_ZOOM_NATURAL) bIllegal=TRUE; 
			if(wID==ID_ZOOM_OUT) bIllegal=TRUE; 
			if(wID==ID_ZOOM_WINDOW) bIllegal=TRUE; 
			if(wID==ID_EDIT_COPY) bIllegal=TRUE; 
			if(wID==ID_RELOAD) bIllegal=TRUE; 
			if(wID==ID_MENU_AREA) bIllegal=TRUE; 
			if(wID==ID_MENU_CONTOUR) bIllegal=TRUE; 
			if(wID==ID_MENU_POINT) bIllegal=TRUE; 
			if(wID==ID_MENU_PLOT) bIllegal=TRUE; 
			if(wID==ID_MENU_INTEGRATE) bIllegal=TRUE; 
			if(wID==ID_MENUSHOWPTS) bIllegal=TRUE; 
			if(wID==ID_KBDZOOM) bIllegal=TRUE; 
			if(wID==ID_SMOOTH) bIllegal=TRUE; 
			if(wID==ID_PAN_DOWN) bIllegal=TRUE; 
			if(wID==ID_PAN_LEFT) bIllegal=TRUE;		
			if(wID==ID_PAN_RIGHT) bIllegal=TRUE; 
			if(wID==ID_PAN_UP) bIllegal=TRUE; 
			if(wID==ID_HELP_FINDER) bIllegal=TRUE; 
			if(wID==ID_VIEW_CIRCPROPS) bIllegal=TRUE; 
			if(wID==ID_EDIT_PREFS) bIllegal=TRUE; 
			if(wID==ID_EDIT_COPY_AS_METAFILE) bIllegal=TRUE;
		}

		if (bIllegal==FALSE) DispatchMessage(&msg);
	}
}

int CbelaviewDoc::lua_dumpheader(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;

	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	return 0;
}

int CbelaviewDoc::lua_getpointvals(lua_State * L)
{
	double px,py;

	px=lua_tonumber(L,1);
	py=lua_tonumber(L,2);

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;

	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();

	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CPointVals u;
	CComplex Jtot;

	if(thisDoc->GetPointValues(px, py, u)==TRUE)
	{
		lua_pushnumber(L,u.V);
		lua_pushnumber(L,u.D.re);
		lua_pushnumber(L,u.D.im);
		lua_pushnumber(L,u.E.re);
		lua_pushnumber(L,u.E.im);
		lua_pushnumber(L,u.e.re);
		lua_pushnumber(L,u.e.im);
		lua_pushnumber(L,u.nrg);
		return 8;
	}

	return 0;
}

int CbelaviewDoc::lua_exitpost(lua_State * L)
{
	lua_byebye=TRUE;
//	could now just ditch lua_byebye and replace with
//	AfxGetMainWnd()->PostMessage(WM_CLOSE);
	return 0;
}

int CbelaviewDoc::lua_addcontour(lua_State * L)
{
	CComplex z;
	int i;
	z.Set(lua_tonumber(L,1),lua_tonumber(L,2));
	
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	i=thisDoc->contour.GetSize();

	if(i>0){
		if (z!=thisDoc->contour[i-1])
				thisDoc->contour.Add(z);
	}
	else thisDoc->contour.Add(z);
	theView->DrawUserContour(FALSE);
	
	return 0;
}

int CbelaviewDoc::lua_clearcontour(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	theView->EraseUserContour(TRUE);
	thisDoc->contour.RemoveAll();
	
	return 0;
}

int CbelaviewDoc::lua_lineintegral(lua_State * LL)
{
	int type;
	double z[4];

	type=(int) lua_tonumber(LL,1); 
	// 0 - E.t
	// 1 - D.n
	// 2 - Cont length
	// 3 - Force from stress tensor
	// 4 - Torque from stress tensor

	if (type<0 || type >4)
	{
		CString msg;
		msg.Format("Invalid line integral selected %d",type);
		lua_error(LL,msg.GetBuffer(1));
		return 0;

	}

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	z[0]=z[1]=0;
	thisDoc->LineIntegral(type,z);

	lua_pushnumber(lua,z[0]);
	lua_pushnumber(lua,z[1]);

	return 2;
}

int CbelaviewDoc::lua_selectblock(lua_State * L)
{
	double px,py;

	px=lua_tonumber(L,1);
	py=lua_tonumber(L,2);

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	theView->EditAction=2;
	int k;
	
	if (thisDoc->meshelem.GetSize()>0){
		k=thisDoc->InTriangle(px,py);
		if(k>=0){
			thisDoc->bHasMask=FALSE;
			thisDoc->blocklist[thisDoc->meshelem[k].lbl].ToggleSelect();
			//	RedrawView();
			theView->DrawSelected=thisDoc->meshelem[k].lbl;
			HDC myDCH=GetDC(theView->m_hWnd);
			CDC tempDC;
			CDC *pDC;
			pDC=tempDC.FromHandle(myDCH);
				
			//CDC *pDC=GetDC(theView->m_hWnd);
			theView->OnDraw(pDC);
			theView->DrawSelected=-1;
			theView->ReleaseDC(pDC);
			thisDoc->UpdateAllViews(theView);
		}
	}

	return 0;
}

int CbelaviewDoc::lua_groupselectblock(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	theView->EditAction=2;
	int j,k,n;
	
	if (thisDoc->meshelem.GetSize()>0)
	{
		n=lua_gettop(L);
		k=0; if (n>0) k=(int)lua_tonumber(L,1);

		for(j=0;j<thisDoc->blocklist.GetSize();j++)
		{
			if ((thisDoc->blocklist[j].InGroup==k) || (n==0))
			thisDoc->blocklist[j].ToggleSelect();
			thisDoc->bHasMask=FALSE;
		}

		HDC myDCH=GetDC(theView->m_hWnd);
		CDC tempDC;
		CDC *pDC;
		pDC=tempDC.FromHandle(myDCH);
				
		//CDC *pDC=GetDC(theView->m_hWnd);
		theView->OnDraw(pDC);
		theView->DrawSelected=-1;
		theView->ReleaseDC(pDC);
		thisDoc->UpdateAllViews(theView);
	}

	return 0;
}

int CbelaviewDoc::lua_clearblock(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	theView->UnselectAll();
	theView->EditAction=0;
	theView->RedrawView();

	return 0;
}


int CbelaviewDoc::lua_blockintegral(lua_State * L)
{
	// 0 - Stored anergy
	// 1 - Area
	// 2 - Volume
	// 3 - Average D
	// 4 - Average E
	// 5 - Weighted Stress Tensor Force
	// 6 - Weighted Stress Tensor Torque

	int type;
	type=(int) lua_tonumber(L,1);

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CComplex z;

	int i;
	BOOL flg=FALSE;
	for(i=0;i<thisDoc->blocklist.GetSize();i++)
		if (thisDoc->blocklist[i].IsSelected==TRUE) flg=TRUE;
	if(flg==FALSE)
	{
		CString msg="Cannot integrate\nNo area has been selected";
		lua_error(L,msg.GetBuffer(1));
		return 0;
	}
	if(type>=5) thisDoc->MakeMask();
	z=thisDoc->BlockIntegral(type); 

	lua_pushnumber(L,z.re);
	lua_pushnumber(L,z.im);

	return 2;
}


int CbelaviewDoc::lua_afxpause(lua_State * L)
{
	AfxMessageBox("LUA pause");
	return 0;
}

void CbelaviewDoc::OnFileOpenLuaScript() 
{
	static char BASED_CODE szFilter[] = "Lua Script Files (*.lua)|*.lua|";
	char ext[]=".lua";	
	CFileDialog MyDlg(TRUE,ext,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,szFilter);
	if(MyDlg.DoModal()==IDOK)
	{
		luascriptname=MyDlg.GetPathName();
		luathread((void *) this);
	}
}

UINT CbelaviewDoc::luathread(LPVOID pParam)
{

//	clock_t wait,time;
//	wait=clock()+2000;
//
//	while(clock()<wait)
//	{
//	}
// Was once a thread during development but was unnecessary

	// catch the case in which luathread is called
	// "by accident" with no scriptname
	if (luascriptname.GetLength()==0) return 0;
	
	// make sure everything gets drawn once;
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	if(thisDoc->FirstDraw!=0)
	{
		theView->InvalidateRect(NULL);
		theView->UpdateWindow();
	}

	int lua_error_code;
	
	lua_byebye=FALSE;
	
	bIsLua=TRUE;
	if (lua_error_code=lua_dofile(lua,luascriptname)!=0)
	{
		//somthing whent wrong !
		if (lua_error_code==LUA_ERRRUN)
			AfxMessageBox("Run Error");
		if (lua_error_code==LUA_ERRSYNTAX)
			AfxMessageBox("Syntax Error");
		if (lua_error_code==LUA_ERRMEM)
			AfxMessageBox("Lua memory Error");
		if (lua_error_code==LUA_ERRERR)
			AfxMessageBox("User error error");
		if (lua_error_code==LUA_ERRFILE)
			AfxMessageBox("File Error");
	}
	bIsLua=FALSE;


	// if the "shut down" flag has been raised, shut
	// the program down in a "gentle" way.  This code
	// does the same thing that happens when you 
	// double-click on the main window close box
	if(lua_byebye==TRUE){
		ASSERT(AfxGetMainWnd() != NULL);
		AfxGetMainWnd()->PostMessage(WM_CLOSE);
	}

	return 0;
}


int CbelaviewDoc::lua_zoomin(lua_State * L)
{

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	
	RECT r;
	double x,y;

	theView->GetClientRect(&r);
	x=r.right; y=r.bottom;

	theView->ox=theView->ox+0.25*x/theView->mag;
	theView->oy=theView->oy+0.25*y/theView->mag;
	theView->mag*=2.;

	theView->RedrawView();

	
	
	
	return 0;
}

int CbelaviewDoc::lua_zoom(lua_State * L)
{
	double x[2],y[2],m[2];

	x[0]=lua_tonumber(L,1);
	y[0]=lua_tonumber(L,2);
	x[1]=lua_tonumber(L,3);
	y[1]=lua_tonumber(L,4);

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CRect r;

	theView->ox=x[0]; theView->oy=y[0];
	theView->GetClientRect(&r);
	m[0]=((double) (r.right-1))/(x[1]-x[0]);
	m[1]=((double) (r.bottom-1))/(y[1]-y[0]);

	if(m[0]<m[1]) theView->mag=m[0];
	else theView->mag=m[1];

	return 0;
}


int CbelaviewDoc::lua_zoomnatural(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);


	CbelaviewDoc *pDoc=theView->GetDocument();
	double x[2],y[2],m[2],w;
	RECT r;
	int i;

	if (pDoc->meshnode.GetSize()<2) return 0;
	x[0]=pDoc->meshnode[0].x;	x[1]=pDoc->meshnode[0].x;
	y[0]=pDoc->meshnode[0].y;	y[1]=pDoc->meshnode[0].y;
	for(i=1;i<pDoc->meshnode.GetSize();i++)
	{
		if(pDoc->meshnode[i].x<x[0]) x[0]=pDoc->meshnode[i].x;
		if(pDoc->meshnode[i].x>x[1]) x[1]=pDoc->meshnode[i].x;
		if(pDoc->meshnode[i].y<y[0]) y[0]=pDoc->meshnode[i].y;
		if(pDoc->meshnode[i].y>y[1]) y[1]=pDoc->meshnode[i].y;
	}

	if(pDoc->FirstDraw==TRUE){
		if((x[1]-x[0])>(y[1]-y[0])) w=x[1]-x[0];
		else w=y[1]-y[0];
		if(w!=0)
			theView->GridSize=pow(10.,floor(log(w)/log(10.)-1.));
	}

	theView->ox=x[0]; theView->oy=y[0];
	theView->GetClientRect(&r);
	m[0]=((double) (r.right-1))/(x[1]-x[0]);
	m[1]=((double) (r.bottom-1))/(y[1]-y[0]);

	if(m[0]<m[1]) theView->mag=m[0];
	else theView->mag=m[1];
	
	if(pDoc->FirstDraw==TRUE) pDoc->FirstDraw=FALSE;
	else theView->RedrawView();	



	return 0;
}

int CbelaviewDoc::lua_zoomout(lua_State * L)
{

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	RECT r;
	double x,y;

	theView->GetClientRect(&r);
	x=r.right; y=r.bottom;
	theView->ox=theView->ox-0.5*x/theView->mag;
	theView->oy=theView->oy-0.5*y/theView->mag;
	theView->mag/=2.;

	theView->RedrawView();

	return 0;
}

int CbelaviewDoc::lua_showmesh(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	theView->MeshFlag=TRUE;
	MMnu->CheckMenuItem(ID_SHOW_MESH, MF_CHECKED);
	tc->CheckButton(ID_SHOW_MESH,TRUE);

	theView->RedrawView();

	return 0;
}

int CbelaviewDoc::lua_hidemesh(lua_State * L)
{

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	theView->MeshFlag=FALSE;
	MMnu->CheckMenuItem(ID_SHOW_MESH, MF_UNCHECKED);
	tc->CheckButton(ID_SHOW_MESH,FALSE);

	theView->RedrawView();

	return 0;
}

int CbelaviewDoc::lua_hidegrid(lua_State * L)
{
	
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	theView->GridFlag=FALSE;
	MMnu->CheckMenuItem(ID_SHOW_GRID, MF_UNCHECKED);
	tc->CheckButton(ID_SHOW_GRID,FALSE);
	theView->RedrawView();

	return 0;
}


int CbelaviewDoc::lua_showgrid(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	theView->GridFlag=TRUE;
	MMnu->CheckMenuItem(ID_SHOW_GRID, MF_CHECKED);
	tc->CheckButton(ID_SHOW_GRID,TRUE);
	theView->RedrawView();

	return 0;
}

int CbelaviewDoc::lua_showdensity(lua_State * L)
{
    bool showlegend;
    bool gscale;
	int PlotType,n;
    double m_ub1,m_lb1;
    CString type;

    CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	n=lua_gettop(L); if(n<3) return 0;

    showlegend=(int) lua_tonumber(L,1);
    gscale=(int) lua_tonumber(L,2);
	PlotType=(int) lua_tonumber(L,3);
	
	if(n>=5)
	{
		m_ub1=lua_tonumber(L,4);
		m_lb1=lua_tonumber(L,5);
	}
	
    if(m_lb1>m_ub1)
    {
        double temp=m_lb1;
        m_lb1=m_ub1;
        m_ub1=temp;
    }

	if ((PlotType>2)|| (PlotType<0)) PlotType=0;

    if (showlegend==-1)
    {
		// load back the default plot range
		m_lb1=thisDoc->d_PlotBounds[PlotType][0];
        m_ub1=thisDoc->d_PlotBounds[PlotType][1];
        showlegend=1;
        gscale=0;
		n=5;
    }

    theView->DensityPlot=PlotType+1; 
    theView->LegendFlag=showlegend;
    theView->GreyContours=gscale;
	if(n>=5)
	{
		thisDoc->PlotBounds[PlotType][1]=m_ub1;
		thisDoc->PlotBounds[PlotType][0]=m_lb1;
	}
    theView->RedrawView();
    
    return 0;
}

int CbelaviewDoc::lua_hidedensity(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	theView->DensityPlot=0;

	theView->RedrawView();

	return 0;
}


int CbelaviewDoc::lua_showcountour(lua_State * L)
{
	int m_numcontours;
	double m_alow,m_ahigh;
	CString type;
	m_numcontours=(int) lua_tonumber(L,1);
	m_alow=lua_tonumber(L,2);
	m_ahigh=lua_tonumber(L,3);

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	
	theView->ShowAr=true;
	thisDoc->A_Low=m_alow;
	thisDoc->A_High=m_ahigh;
	theView->NumContours=m_numcontours;
	theView->RedrawView();
	
	if(m_numcontours==-1)
	{
		thisDoc->A_Low=thisDoc->A_lb;
		thisDoc->A_High=thisDoc->A_ub;
		theView->NumContours=19;
	}

	theView->RedrawView();
	
	return 0;
}

int CbelaviewDoc::lua_hidecountour(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	theView->ShowAr=FALSE;
	
	theView->RedrawView();
	return 0;
}

int CbelaviewDoc::lua_smoothing(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CString temp;
	temp.Format("%s",lua_tostring(L,1));
	temp.MakeLower();

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();


	if (temp=="off")
	{
		thisDoc->Smooth=FALSE;
		MMnu->CheckMenuItem(ID_SMOOTH, MF_UNCHECKED);

	}
	if (temp=="on")
	{
			thisDoc->Smooth=TRUE;
			MMnu->CheckMenuItem(ID_SMOOTH, MF_CHECKED);
	}


		if (temp !="on" && temp !="off")
	{
		CString msg="Unknown option for smoothing";
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}



	theView->RedrawView();

	return 0;
}


int CbelaviewDoc::lua_showpoints(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CFrameWnd *MFrm;
	MFrm=theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();

	theView->PtsFlag=TRUE;
	MMnu->CheckMenuItem(ID_MENUSHOWPTS, MF_CHECKED);

	theView->RedrawView();

	return 0;
}

int CbelaviewDoc::lua_hidepoints(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CFrameWnd *MFrm;
	MFrm=theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();

	theView->PtsFlag=FALSE;
	MMnu->CheckMenuItem(ID_MENUSHOWPTS, MF_UNCHECKED);

	theView->RedrawView();
	
	return 0;
}

int CbelaviewDoc::lua_gridsnap(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CString temp;
	temp.Format("%s",lua_tostring(L,1));
	temp.MakeLower();

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)theView->GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	if(temp=="off"){
		theView->SnapFlag=FALSE;
		MMnu->CheckMenuItem(ID_SNAP_GRID, MF_UNCHECKED);
		tc->CheckButton(ID_SNAP_GRID,FALSE);
	}
	else{
		theView->SnapFlag=TRUE;
		MMnu->CheckMenuItem(ID_SNAP_GRID, MF_CHECKED);
		tc->CheckButton(ID_SNAP_GRID,TRUE);
	}
	

		if (temp !="on" && temp !="off")
	{
		CString msg="Unknown option for grid snap";
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}


	return 0;
}


int CbelaviewDoc::lua_setgrid(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	CString temp;
	int coords=0;
	double gridsize;

	gridsize=lua_tonumber(L,1);
	temp.Format("%s",lua_tostring(L,2));
	temp.MakeLower();

	if (temp=="cart")  coords=0;
	if (temp=="polar") coords=1;

		if (temp !="cart" && temp !="polar")
	{
		CString msg="Unknown option for set grid";
		lua_error(L,msg.GetBuffer(1));
		return 0;

	}


	theView->GridSize=gridsize;
	thisDoc->Coords=coords;
	theView->RedrawView();

	return 0;
}

int CbelaviewDoc::lua_getprobleminfo(lua_State * L)
{
	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	lua_pushnumber(L,thisDoc->ProblemType);
	lua_pushnumber(L,thisDoc->Depth);

	return 2;
}

int CbelaviewDoc::lua_savebitmap(lua_State * L)
{

        CbelaviewDoc * thisDoc;
        CbelaviewView * theView;
        thisDoc=(CbelaviewDoc *)pFemmviewdoc;
        POSITION pos;
        pos=thisDoc->GetFirstViewPosition();
        theView=(CbelaviewView *)thisDoc->GetNextView(pos);

        CString filename;

        filename.Format("%s",lua_tostring(L,1));

		RECT r;
		CDC tempDC;
		CBitmap bitmap;
		CDC *pDC=theView->GetDC();

        theView->GetClientRect(&r);

		tempDC.CreateCompatibleDC(pDC);
        bitmap.CreateCompatibleBitmap(pDC, r.right, r.bottom);
		tempDC.SelectObject(&bitmap);
        tempDC.Rectangle(0,0,r.right,r.bottom);
		
        theView->OnDraw(&tempDC);
        //    tempDC.BitBlt(0, 0, r.right, r.bottom, pDC, 0, 0, SRCCOPY);


        PBITMAPINFO pbmi;

        pbmi=thisDoc->CreateBitmapInfoStruct(theView->m_hWnd,HBITMAP(bitmap));
        thisDoc->CreateBMPFile(theView->m_hWnd,filename.GetBuffer(1),pbmi,HBITMAP(bitmap),tempDC.m_hDC);

        // to save a bitmap file we need
        // a bitmapheader lets use the v5

 //        OpenClipboard();
   // EmptyClipboard();
  //  SetClipboardData(CF_BITMAP, HBITMAP(bitmap));
  //  CloseClipboard();
return 0;
}


PBITMAPINFO CbelaviewDoc::CreateBitmapInfoStruct(HWND hwnd, HBITMAP hBmp)
{
    BITMAP bmp;
    PBITMAPINFO pbmi;
    WORD    cClrBits;

    // Retrieve the bitmap's color format, width, and height.
    if (!GetObject(hBmp, sizeof(BITMAP), (LPSTR)&bmp))
        {//errhandler("GetObject", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");
        }
    // Convert the color format to a count of bits.
    cClrBits = (WORD)(bmp.bmPlanes * bmp.bmBitsPixel);
    if (cClrBits == 1)
        cClrBits = 1;
    else if (cClrBits <= 4)
        cClrBits = 4;
    else if (cClrBits <= 8)
        cClrBits = 8;
    else if (cClrBits <= 16)
        cClrBits = 16;
    else if (cClrBits <= 24)
        cClrBits = 24;
    else cClrBits = 32;

    // Allocate memory for the BITMAPINFO structure. (This structure
    // contains a BITMAPINFOHEADER structure and an array of RGBQUAD
    // data structures.)

     if (cClrBits >= 24)
         pbmi = (PBITMAPINFO) LocalAlloc(LPTR,
                    sizeof(BITMAPINFOHEADER) +
                    sizeof(RGBQUAD) * (1<< cClrBits));

     // There is no RGBQUAD array for the 24-bit-per-pixel format.

     else
         pbmi = (PBITMAPINFO) LocalAlloc(LPTR,
                    sizeof(BITMAPINFOHEADER));

    // Initialize the fields in the BITMAPINFO structure.

    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    pbmi->bmiHeader.biWidth = bmp.bmWidth;
    pbmi->bmiHeader.biHeight = bmp.bmHeight;
    pbmi->bmiHeader.biPlanes = bmp.bmPlanes;
    pbmi->bmiHeader.biBitCount = bmp.bmBitsPixel;
    if (cClrBits < 24)
        pbmi->bmiHeader.biClrUsed = (1<<cClrBits);

    // If the bitmap is not compressed, set the BI_RGB flag.
    pbmi->bmiHeader.biCompression = BI_RGB;

    // Compute the number of bytes in the array of color
    // indices and store the result in biSizeImage.
    // For Windows NT/2000, the width must be DWORD aligned unless
    // the bitmap is RLE compressed. This example shows this.
    // For Windows 95/98, the width must be WORD aligned unless the
    // bitmap is RLE compressed.
    pbmi->bmiHeader.biSizeImage = ((pbmi->bmiHeader.biWidth * cClrBits +31) & ~31) /8
                                  * pbmi->bmiHeader.biHeight;
    // Set biClrImportant to 0, indicating that all of the
    // device colors are important.
     pbmi->bmiHeader.biClrImportant = 0;
     return pbmi;
 }


void CbelaviewDoc::CreateBMPFile(HWND hwnd, LPTSTR pszFile, PBITMAPINFO pbi,
                  HBITMAP hBMP, HDC hDC)
 {
     HANDLE hf;                 // file handle
    BITMAPFILEHEADER hdr;       // bitmap file-header
    PBITMAPINFOHEADER pbih;     // bitmap info-header
    LPBYTE lpBits;              // memory pointer
    DWORD dwTotal;              // total count of bytes
    DWORD cb;                   // incremental count of bytes
    BYTE *hp;                   // byte pointer
    DWORD dwTmp;

    pbih = (PBITMAPINFOHEADER) pbi;
    lpBits = (LPBYTE) GlobalAlloc(GMEM_FIXED, pbih->biSizeImage);

    if (!lpBits)
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");
//              errhandler("GlobalAlloc", hwnd);

    // Retrieve the color table (RGBQUAD array) and the bits
    // (array of palette indices) from the DIB.
    if (!GetDIBits(hDC, hBMP, 0, (WORD) pbih->biHeight, lpBits, pbi,
        DIB_RGB_COLORS))
    {
    //    errhandler("GetDIBits", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

        }

    // Create the .BMP file.
    hf = CreateFile(pszFile,
                   GENERIC_READ | GENERIC_WRITE,
                   (DWORD) 0,
                    NULL,
                   CREATE_ALWAYS,
                   FILE_ATTRIBUTE_NORMAL,
                   (HANDLE) NULL);
    if (hf == INVALID_HANDLE_VALUE)
    {//    errhandler("CreateFile", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

        }
        hdr.bfType = 0x4d42;        // 0x42 = "B" 0x4d = "M"
    // Compute the size of the entire file.
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
                 pbih->biSize + pbih->biClrUsed
                 * sizeof(RGBQUAD) + pbih->biSizeImage);
    hdr.bfReserved1 = 0;
    hdr.bfReserved2 = 0;

    // Compute the offset to the array of color indices.
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
                    pbih->biSize + pbih->biClrUsed
                    * sizeof (RGBQUAD);

    // Copy the BITMAPFILEHEADER into the .BMP file.
    if (!WriteFile(hf, (LPVOID) &hdr, sizeof(BITMAPFILEHEADER),
        (LPDWORD) &dwTmp,  NULL))
    {
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

        //      errhandler("WriteFile", hwnd);
    }

    // Copy the BITMAPINFOHEADER and RGBQUAD array into the file.
    if (!WriteFile(hf, (LPVOID) pbih, sizeof(BITMAPINFOHEADER)
                  + pbih->biClrUsed * sizeof (RGBQUAD),
                  (LPDWORD) &dwTmp, ( NULL)))
//        errhandler("WriteFile", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

    // Copy the array of color indices into the .BMP file.
    dwTotal = cb = pbih->biSizeImage;
    hp = lpBits;
    if (!WriteFile(hf, (LPSTR) hp, (int) cb, (LPDWORD) &dwTmp,NULL))
//           errhandler("WriteFile", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

    // Close the .BMP file.
     if (!CloseHandle(hf))
//           errhandler("CloseHandle", hwnd);
        AfxMessageBox("Critical error on getting bmp info, possible page fault ahoy");

    // Free memory.
    GlobalFree((HGLOBAL)lpBits);
}

int CbelaviewDoc::lua_ERROR(lua_State *L)
{

	CString errmsg;
	errmsg.Format("%s",lua_tostring(L,1));


	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	// Somthing went wrong in lua execution
	// Windows dosn't have stdout so lets afxmessagebox it

	AfxMessageBox(errmsg);
	
return 0;
}

int CbelaviewDoc::lua_messagebox(lua_State *L)
{

	CString errmsg;
	errmsg.Format("%s",lua_tostring(L,1));

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	AfxMessageBox(errmsg,MB_ICONINFORMATION);
	
	return 0;
}

int CbelaviewDoc::lua_getcircuitprops(lua_State *L)
{
	CbelaviewDoc * TheDoc; // note normally thisdoc
	CbelaviewView * theView;
	TheDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=TheDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)TheDoc->GetNextView(pos);
	
	int NumCircuits,i,k;
	CString circuitname;
	circuitname=lua_tostring(L,1);
	k=-1;

	// ok we need to find the correct entry for the circuit name
	NumCircuits=TheDoc->circproplist.GetSize();
	for(i=0;i<NumCircuits;i++)
	{
		if(TheDoc->circproplist[i].CircName==circuitname)
		{	
			k=i;
			i=NumCircuits; // that will break it
		}
	}	

// trap errors

		if(k==-1)
		{
		CString msg="Unknown conductor";
		lua_error(L,msg.GetBuffer(1));
		return 0;
		}

	lua_pushnumber(L,TheDoc->circproplist[k].V);
	lua_pushnumber(L,TheDoc->circproplist[k].q);
	return 2;
}

int CbelaviewDoc::lua_saveWMF(lua_State * L)
{

	CbelaviewDoc * thisDoc;
	CbelaviewView * theView;
	thisDoc=(CbelaviewDoc *)pFemmviewdoc;
	POSITION pos;
	pos=thisDoc->GetFirstViewPosition();
	theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	CString filename;

	filename.Format("%s",lua_tostring(L,1));

	RECT r;
	CDC tempDC;
	CDC *pDC=theView->GetDC();

	CMetaFileDC Meta;
	CRgn R;

	Meta.CreateEnhanced(NULL,NULL,NULL,NULL);
	theView->GetClientRect(&r);
	R.CreateRectRgnIndirect(&r);
	Meta.SelectClipRgn(&R);
	theView->OnDraw(&Meta);
	HENHMETAFILE hMeta=Meta.CloseEnhanced();

	CopyEnhMetaFile(hMeta,filename);

	return 0;
}

int CbelaviewDoc::lua_refreshview(lua_State * L)
{
    CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);

    CDC *pDC=theView->GetDC();
    
	// erase background
    CBrush backBrush(theView->BackColor);
    CBrush* pOldBrush = pDC->SelectObject(&backBrush);
    CRect rect;
    pDC->GetClipBox(&rect);
    pDC->PatBlt(rect.left, rect.top, rect.Width(),
       rect.Height(), PATCOPY);
    pDC->SelectObject(pOldBrush);

	// redraw the view
    theView->OnDraw(pDC);

	return 0;
}

int CbelaviewDoc::lua_selectline(lua_State *L)
{
        CbelaviewDoc * pDoc; // note normally thisdoc
        CbelaviewView * theView;
        pDoc=(CbelaviewDoc *)pFemmviewdoc;
        POSITION pos;
        pos=pDoc->GetFirstViewPosition();
        theView=(CbelaviewView *)pDoc->GetNextView(pos);

        theView->EditAction=1; // make sure things update OK

        double mx,my;
        int i,j,k,m;

        mx=lua_tonumber(L,1);
        my=lua_tonumber(L,2);


//***************
        {
                if (pDoc->nodelist.GetSize()>0){
                        i=pDoc->ClosestNode(mx,my);
                        CComplex x,y,z;
                        double R,d1,d2;
                        int lineno,arcno,flag=0;
                        z.Set(pDoc->nodelist[i].x,pDoc->nodelist[i].y);

                        if (pDoc->contour.GetSize()>0){

                                //check to see if point is the same as last point in the contour;
                                y=pDoc->contour[pDoc->contour.GetSize()-1];
                                if ((y.re==z.re) && (y.im==z.im)) return 0;

                                j=pDoc->ClosestNode(y.re,y.im);
                                x.Set(pDoc->nodelist[j].x,pDoc->nodelist[j].y);

                                //check to see if this point and the last point are ends of an
                                //input segment;
                                lineno=-1;
                                d1=1.e08;

                                if (abs(x-y)<1.e-08){
                                        for(k=0;k<pDoc->linelist.GetSize();k++){
                                                if((pDoc->linelist[k].n0==j) && (pDoc->linelist[k].n1==i))
                                                {
                                                        d2=fabs(pDoc->ShortestDistanceFromSegment(mx,my,k));
                                                        if(d2<d1){
                                                                lineno=k;
                                                                d1=d2;
                                                        }
                                                }
                                                if((pDoc->linelist[k].n0==i) && (pDoc->linelist[k].n1==j))
                                                {
                                                        d2=fabs(pDoc->ShortestDistanceFromSegment(mx,my,k));
                                                        if(d2<d1){
                                                                lineno=k;
                                                                d1=d2;
                                                        }
                                                }
                                        }
                                }

                                //check to see if this point and last point are ends of an
                                // arc segment; if so, add entire arc to the contour;
                                arcno=-1;
                                if (abs(x-y)<1.e-08){
                                        for(k=0;k<pDoc->arclist.GetSize();k++){
                                                if((pDoc->arclist[k].n0==j) && (pDoc->arclist[k].n1==i))
                                                {
                                                        d2=pDoc->ShortestDistanceFromArc(CComplex(mx,my),
                                                           pDoc->arclist[k]);
                                                        if(d2<d1){
                                                                arcno=k;
                                                                lineno=-1;
                                                                flag=TRUE;
                                                                d1=d2;
                                                        }
                                                }
                                                if((pDoc->arclist[k].n0==i) && (pDoc->arclist[k].n1==j))
                                                {
                                                        d2=pDoc->ShortestDistanceFromArc(CComplex(mx,my),
                                                           pDoc->arclist[k]);
                                                        if(d2<d1){
                                                                arcno=k;
                                                                lineno=-1;
                                                                flag=FALSE;
                                                                d1=d2;
                                                        }
                                                }
                                        }
                                }

                        }
                        else{
                                pDoc->contour.Add(z);
                                theView->DrawUserContour(FALSE);
                                return 0;
                        }

                        if((lineno<0) && (arcno<0)){
                                pDoc->contour.Add(z);
                                theView->DrawUserContour(FALSE);
                        }

                        if(lineno>=0){
                                j=pDoc->contour.GetSize();
                                if(j>1){
                                        if(abs(pDoc->contour[j-2]-z)<1.e-08){
                                                //CView::OnLButtonDown(nFlags, point);
                                                return 0;
                                        }
                                }
                                pDoc->contour.Add(z);
                                theView->DrawUserContour(FALSE);
                        }
                        if(arcno>=0){
                                k=arcno;
                                pDoc->GetCircle(pDoc->arclist[k],x,R);
                                j=(int) ceil(pDoc->arclist[k].ArcLength/pDoc->arclist[k].MaxSideLength);
                                if(flag==TRUE)
                                        z=exp(I*pDoc->arclist[k].ArcLength*PI/(180.*((double) j)) );
                                else
                                        z=exp(-I*pDoc->arclist[k].ArcLength*PI/(180.*((double) j)) );
                                for(i=0;i<j;i++){
                                        y=(y-x)*z+x;
                                        m=pDoc->contour.GetSize();
                                        if(m>1){
                                                if(abs(pDoc->contour[m-2]-y)<1.e-08){
                                                        //CView::OnLButtonDown(nFlags, point);
                                                        return 0;
                                                }
                                        }
                                        pDoc->contour.Add(y);
                                        theView->DrawUserContour(FALSE);
                                }
                        }
                }
        }


//*************
        return 0;
}




int CbelaviewDoc::lua_showpointprops(lua_State *L)
{
        CbelaviewDoc * thisDoc;
        CbelaviewView * theView;
        thisDoc=(CbelaviewDoc *)pFemmviewdoc;
        POSITION pos;
        pos=thisDoc->GetFirstViewPosition();
        theView=(CbelaviewView *)thisDoc->GetNextView(pos);

        CMainFrame * pfrm;
        pfrm=(CMainFrame *)AfxGetApp()->GetMainWnd();
        pfrm->ShowControlBar(&pfrm->m_dlgBar,TRUE,FALSE);
        return 0;
}


int CbelaviewDoc::lua_hidepointprops(lua_State *L)
{
    CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;

    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);
    CMainFrame * pfrm;
    pfrm=(CMainFrame *)AfxGetApp()->GetMainWnd();
    pfrm->ShowControlBar(&pfrm->m_dlgBar,FALSE,FALSE);
    theView->Invalidate(true);

	return 0;
}

int CbelaviewDoc::lua_seteditmode(lua_State *L)
{
    CString EditAction;

    EditAction.Format("%s",lua_tostring(L,1));
    EditAction.MakeLower();
 
	CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	    if (EditAction=="point")
		{
			if (theView->EditAction==1){
				theView->EraseUserContour(TRUE);
				thisDoc->contour.RemoveAll();
			}
			if (theView->EditAction==2){
				int i;
				BOOL flg=FALSE;
				thisDoc->bHasMask=FALSE;
				for(i=0;i<thisDoc->blocklist.GetSize();i++)
				{
					if (thisDoc->blocklist[i].IsSelected==TRUE)
					{
						thisDoc->blocklist[i].IsSelected=FALSE;
						flg=TRUE;
					}
				}
				if(flg==TRUE) theView->RedrawView();
			}
			theView->EditAction=0;
	}
    if (EditAction=="contour")
	{
		if(theView->EditAction==2){
			int i;
			BOOL flg=FALSE;
			thisDoc->bHasMask=FALSE;
			for(i=0;i<thisDoc->blocklist.GetSize();i++){
				if (thisDoc->blocklist[i].IsSelected==TRUE)
				{
					thisDoc->blocklist[i].IsSelected=FALSE;
					flg=TRUE;
				}
			}
		
			if(flg==TRUE) theView->RedrawView();
		}
		theView->EditAction=1;
	}
    if (EditAction=="area")
	{
		if(theView->EditAction==1){
			theView->EraseUserContour(TRUE);
			thisDoc->contour.RemoveAll();
		}
		theView->EditAction=2;
	}

	return 0;
}

int CbelaviewDoc::lua_bendcontour(lua_State *L)
{
	CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);
	
	thisDoc->BendContour(lua_tonumber(L,1),lua_tonumber(L,2));
	theView->InvalidateRect(NULL);

	return 0;
}

int CbelaviewDoc::lua_promptbox(lua_State *L)
{
	CPromptBox dlg;

	int n=lua_gettop(L);
	if(n>0) dlg.mytitle = lua_tostring(L,1);
	dlg.DoModal();
	lua_pushstring(L,dlg.instring);

	return TRUE;
}

int CbelaviewDoc::lua_makeplot(lua_State *L) 
{
	CbelaviewDoc *pDoc;
    CbelaviewView *pView;
    pDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=pDoc->GetFirstViewPosition();
    pView=(CbelaviewView *)pDoc->GetNextView(pos);
	
	int PlotType,npoints,FileFormat,n;
	CString ToFile;

//	if ((pView->EditAction!=1) || (pDoc->contour.GetSize()==0)){
	if (pDoc->contour.GetSize()==0){
		CString outmsg;
		outmsg.Format("*** Cannot create a plot;\r\n*** No contour has been defined\r\n");
		pDoc->LuaConsole.ToOutput(outmsg);
		return TRUE;
	}
	
	n=lua_gettop(L);
	
	if(n>0) PlotType=(int) lua_tonumber(L,1);
	else return FALSE;

	if(n>1) npoints=(int) lua_tonumber(L,2);
	else npoints=pView->d_PlotPoints;
		
	CXYPlot xyplot;
	pDoc->GetLineValues(xyplot,PlotType,npoints);
	
	if(n<3)
	{
		CMetaFileDC Meta;	
		Meta.CreateEnhanced(NULL,NULL,NULL,NULL);
		HGLOBAL BoundingBox=GlobalAlloc(0,256);
		xyplot.MakePlot(&Meta,(char *) BoundingBox);
		HENHMETAFILE hMeta=Meta.CloseEnhanced();
		if (hMeta==NULL) AfxMessageBox("No Handle...");
		if (pView->OpenClipboard()==FALSE)
			AfxMessageBox("Cannot access the Clipboard");
		else{
			EmptyClipboard();
			if(SetClipboardData(CF_ENHMETAFILE,hMeta)==NULL)
				AfxMessageBox("Couldn't SetClipboardData");
			if(SetClipboardData(CF_TEXT,BoundingBox)==NULL)
				AfxMessageBox("Couldn't SetClipboardData");
			CloseClipboard();
				char CommandLine[512];
				sprintf(CommandLine,"\"%sfemmplot.exe\"",pView->BinDir);
				STARTUPINFO StartupInfo2 = {0};
			PROCESS_INFORMATION ProcessInfo2;
			StartupInfo2.cb = sizeof(STARTUPINFO);
			if (CreateProcess(NULL,CommandLine, NULL, NULL, FALSE,
				0, NULL, NULL, &StartupInfo2, &ProcessInfo2)){
			}
			else
			{
				pDoc->LuaConsole.ToOutput("*** Problem executing femmplot\r\n");
				return FALSE;
			}
		} 
	}
	else{
		ToFile.Format("%s",lua_tostring(L,3));
		
		if(n>3){
			FileFormat=(int) lua_tonumber(L,4);
			if (xyplot.ToDisk(FileFormat,ToFile)==FALSE)	
				pDoc->LuaConsole.ToOutput("*** Couldn't write data to disk\r\n");
		}
		else{
			CMetaFileDC Meta;	
			Meta.CreateEnhanced(NULL,NULL,NULL,NULL);
			HGLOBAL BoundingBox=GlobalAlloc(0,256);
			xyplot.MakePlot(&Meta,(char *) BoundingBox);
			HENHMETAFILE hMeta=Meta.CloseEnhanced();
			if (hMeta==NULL) AfxMessageBox("No Handle...");
			CopyEnhMetaFile(hMeta,ToFile);
		}
	}

	return TRUE;
}

int CbelaviewDoc::lua_selectconductor(lua_State *L)
{
	int n=lua_gettop(L);
	if (n==0) return 0;
	
	int j,i;
	CString name;
	name=lua_tostring(L,1);
	
	CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	for(i=0,j=-1;i<thisDoc->circproplist.GetSize();i++)
	{

		if (name==thisDoc->circproplist[i].CircName)
		{
			j=i;
			break;
		}
	}

	if (j<0) return 0;
	
	// now, the group associated with the nearest entity is in j;
	// toggle the select of all objects in this group;
	for(i=0;i<thisDoc->nodelist.GetSize();i++)
		if (thisDoc->nodelist[i].InConductor==j) thisDoc->nodelist[i].ToggleSelect();
	for(i=0;i<thisDoc->linelist.GetSize();i++)
		if (thisDoc->linelist[i].InConductor==j) thisDoc->linelist[i].ToggleSelect();
	for(i=0;i<thisDoc->arclist.GetSize();i++)
		if (thisDoc->arclist[i].InConductor==j) thisDoc->arclist[i].ToggleSelect();
	for(i=0;i<thisDoc->meshnode.GetSize();i++)
	{
		if (thisDoc->meshnode[i].Q==j) 
		{
			thisDoc->meshnode[i].IsSelected=1-thisDoc->meshnode[i].IsSelected;
		}
	}
	theView->RedrawView();
	
	return 0;
}

int CbelaviewDoc::lua_shownames(lua_State * L)
{
	CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	int flg=(int)lua_tonumber(L,1);
	if (flg!=0) flg=1;
	theView->ShowNames=flg;
	theView->InvalidateRect(NULL);

	return 0;
}

int CbelaviewDoc::lua_vectorplot(lua_State * L)
{
	CbelaviewDoc * thisDoc;
    CbelaviewView * theView;
    thisDoc=(CbelaviewDoc *)pFemmviewdoc;
    POSITION pos;
    pos=thisDoc->GetFirstViewPosition();
    theView=(CbelaviewView *)thisDoc->GetNextView(pos);

	int n=lua_gettop(L);	
	if (n>0) theView->VectorPlot=(int)lua_tonumber(L,1);
	if (n>1) theView->VectorScaleFactor=lua_tonumber(L,2);

	theView->InvalidateRect(NULL);

	return 0;
}